
# My menus.		

menu -n File -p fileMenuProc {
	"/Nnew"
	"/Oopen"
	"/Wclose"
	"closeAll"
	"(-"
	"/Ssave"
	"saveAs"
	"saveAll"
	"revert"
	"(-"
	"/Yshell"
	"(-"
	"pageSetup"
	"/Pprint"
	"(-"
	"/Qquit"
}

proc fileMenuProc {menu item} {
	if {$item == "open"} {
		findFile
	} elseif {$item == "close"} {
		killWindow
	} else {
		$item
	}
}


menu -n Edit {
	"/Zundo"
	"/Dredo"
	"/Lload"
	"(-"
	"/Xcut"
	"/Ccopy"
	"/Vpaste"
	"(-"
	"/.pastePop"
	"yank"
	"/AselectAll"
	"clear"
	"(-"
	{/[shiftLeft}
	{/]shiftRight}
	"/Bbalance"
}


menu -n Search {
	"/Ffind"
	"/GrepeatSearchForward"
	"/IrepeatSearchBackward"
	"/TfindInNextFile"
	"searchStart"
	"(-"
	"/EenterSelection"
	"(-"
	"/Ureplace"
	"/Hreplace&FindAgain"
	"replaceAll"
	"(-"
	"/ gotoLine"
	{menu -n namedMarks -p namedMarkProc {
		"set"
		"goto"
		"remove"
		"(-"
		"sort"
		"sortByPosition"}}
	{menu -n unnamedMark -p unnamedMarkproc {
		"set"
		"exchangePointAndMark"
		"/=hilite"}}
	{menu -n markStack -p markMenuProc { "push" "pop"}}
	{menu -n registers { pointToRegister jumpToRegister }}
}

proc namedMarkProc {menu item} {
	switch $item {
		"set" 				{setNamedMark}
		"goto"				{gotoNamedMark}
		"remove"			{removeNamedMark}
		"sort"				{sortMarksFile}
		"sortByPosition"	{orderMarks}
	}
}

proc unnamedMarkproc {menu item} {
	switch $item {
		"set" 					{setMark}
		"exchangePointAndMark"	{exchangePointAndMark}
		"hilite"				{markHilite}
	}
}
	
proc markMenuProc {menu item} {
	switch $item {
		"push" 	{pushMark}
		"pop"	{popMark}
	}
}
		
	
proc installProc {menu item} {
	switch $item {
		"Electric Alias" 	{loadElectricAlias}
		"HTML"				{loadHTML}
		"LaTeX 2.09"		{loadLaTeX}
		"LaTeX2e"			{loadLaTeX}
		"MacPerl"			{loadMacPerl}
	}
}


menu -n "Utils" {
		{menu -n fileUtils {
			"insertPathName"
			"insertFile"
			"fileRemove"
			"fileInfo"
			"wordCount"}}
		{menu -m -n compare -p compareProc {
			"Windows"
			"Files"
			"(Directories"}}
		"(-"
		"evaluate"
		{menu -n KbdMacros {
			"startKeyboardMacro"
			"endKeyboardMacro"
			"executeKeyboardMacro"
			"dumpMacro"}}
		"(-"
		"sortLines"
		"matchingLines"
		"gotoMatch"
		"spellcheckWindow"
		"(-"
		{menu -n NamedClipboards -p namedClipMenuProc {"copy" "cut" "paste"}}
		{menu -m -n install -p installProc {
			"Electric Alias"
			"HTML"
			"MacPerl"
			"(-"
			"LaTeX2e"
			"LaTeX 2.09"
		}}
}

proc compareProc {menu item} {
	catch {compare$item} msg
	message $msg
}

proc namedClipMenuProc {menu item} {
	switch $item {
		"copy" 		"copyNamedClipboard"
		"cut" 		"cutNamedClipboard"
		"paste" 	"pasteNamedClipboard"
	}
}

		
menu	-n Mode {
		{menu -n flags -p editFlag {}}
		{menu -n vars -p editVar {}}
		"(-"
		"describeBinding"
		"listBindings"
		{menu -n asciiEtc {
			"quoteChar"
			"(-"
			"keyCode"
			"keyAscii"
			"getAscii"
			"insertAscii"}}
		"(-"
		"setFontsTabs"
		"(-"
		{menu -m -n switchTo -p switchProc {
			"Add"
			"(-"}}
		"toolserverShell"
}

# ==== NOTE:  rectMarkHilite, onespace, centerRedraw, doTab
menu	-n Convert {
		"fillRegion"
		"fillParagraph"
		"wrapRegion"
		"wrapParagraph"
		"(-"
		"zapInvisibles"
		"tabsToSpaces"
		"spacesToTabs"
		"(-"
		{menu	-n Strings {
			"insertPrefix"
			"insertSuffix"
			"removePrefix"
			"removeSuffix"
			"setPrefix"
			"setSuffix"}}
		{menu	-n Comment {
			"transposeChars"
			"transposeWords"
			"commentBox"
			"uncommentBox"}}
		"(-"
		{menu	-n Filters {
			"replaceInRegion"
			"filterLines"
			"filterParagraphs"
			"sortParagraphs"
			"fillRegionByPar"
			"lineToParagraph"
			"paragraphToLine"}}
		"downcaseRegion"
		"upcaseRegion"
}

# Real Kludge
proc helpMenuProc {menu item} {
	global HOME helpMenu
	
	if {$menu == $helpMenu} {
		edit -r $HOME:Help:$item
	} else {
		edit -r $HOME:Help:$menu:$item
	}
	if {$item == "Intro"} {
		global winModes
		
		set nm [lindex [winNames -f] 0]
		set winModes($nm) Help
		changeMode Help
	}
}

proc strip {arg} {
	if {[regsub -all {\\([][\{\}])} $arg {\1} v]} {return $v}
	return $arg
}


set men {Intro "(-" "Alpha Commands" "Tcl Commands" "(-" }
foreach f [lsort -ignore [glob $HOME:Help:*]] {
	set f [file tail $f]
	if {($f != "Intro") && ($f != "Alpha Commands") && ($f != "Tcl Commands")} {
		lappend men $f
	}
}
	
menu -n $helpMenu -m -p helpMenuProc $men
unset men


proc escapeSpaces {str} {
	regsub -all { } $str {\ } str2
	return $str2
}


proc switchProc {menu name} {
	global switchTo

	if {$name == "Add"} then {
		set fName [getfile "Pick an app:"]
		set nm [file tail $fName]
		addMenuItem -m switchTo $nm
		addUserLine "addMenuItem -m switchTo \"$nm\""

		set switchTo($nm) "$fName"
		addUserLine "set switchTo([escapeSpaces $nm]) \{$fName\}"
	} else {
		set blah [array names switchTo]
		if {[catch {switchTo $name}]} {
			launch -f $switchTo($name)
		}
	}
}
		

menu -n $winMenu -p menuWin {
		{menu -n arrange {
			"vertically^1"
			"horizontally^2"
			"tiled^3"
			"overlay^4"}}
		"(-"
		"//zoom"
		"iconify"
		"dispFullName"
		"toggleScrollbar"
		"(-"
		"nextWindow"
		"swapWithNext"
		"/;chooseAWindow"
		"(-"
}


# We may be reloading, so add whatever windows we have
if {[info exists winNameToNum]} {
	set nms [array names winNameToNum]
	foreach name $nms {
		if {$fullNames} {
			set item $name
		} else {
			regexp {[^:]*$} $name item
		}
		set num $winNameToNum($name)
		if {$num < 10} 	{
			addMenuItem -m $winMenu /$num$item
		} else {
			addMenuItem -m $winMenu $item
		}
	}
}

insertMenu "File"
insertMenu "Edit"
insertMenu "Search"
insertMenu "Utils"
insertMenu "Mode"
enableMenuItem NamedClipboards pasteNamedClipboard off
insertMenu "Convert"
menu -n $fsetMenuName {}; insertMenu $fsetMenuName
insertMenu $winMenu
catch {insertMenu $helpMenu}


# The 'Files' menu can instantiate itself from the THINK Project Manager if 
# it is running. 
menu -n $thinkMenu {
	"/-think"
	"openHeader"
	"menu -n thinkFlags {}"
	"(-"
	"/Kcompile"
	"checkSyntax"
	"searchNextFile"
	"(-"
	"add"
	"addAndCompile"
	"(-"
	"disassemble"
	"preprocess"
	"precompile"
	"(-"
	"bringUpToDate"
	"make"
	"(-"
	"debug"
	"/Rrun"
}


menu -n "$cwarrierMenu" -p codeWarrierProc {
	"switchTo"
	"(-"
	"addFile"
	"compile"
	"(-"
	"update"
	"make"
	"(-"
	"run"
}



menu -n $thinkRefMenu {
	"gotoReference"
	"(-"
	"displayTrapTemplate"
	"insertTrapTemplate"
	"lookupTrap"
}

menu -n $tclMenu -p tclMenuProc {
	"traceTclProc"
	"(dumpTraces"
	"(-"
	"rebuildTclIndices"
	"(-"
	"getVarValue"
	"procDefinition"
}


menu -n $terrMenu {}

menu -n $toolserverMenu {}
