
#================================================================================
# This is my current 'userStartup.tcl'. Use this as an example of what can
# be done. Do not use any of this directly, as the your files are doubtless in
# different locations than mine.
#================================================================================

set CmodeVars(thinkDebugger) 	1
set blockCursor 				0
set backup 						1
set backDir						"$HOME:back"
set horScrollBar 				0

bind 'p' <e> fillParagraphSentence
bind 'j' <e>	fillParagraph

#================================================================================
if {[file exists "$HOME:EditSource"]} {
	set fileSets(Editor) [glob -t TEXT "$HOME:EditSource:*.c"]
	addMenuItem -m choose "Editor"
}
#================================================================================
# Lines added automatically.
#================================================================================

set modeMenus(Text) { {thinkMenu}  }
set thinkName "Internal:Development:Symantec C\+\+ for Macintosh:THINK Project Manager"
set referencePath "Internal:Buckaroo:Buckaroo 2.0b1"
set texturesPath "Internal:Textures:Textures"
addMenuItem -m switchTo "VersaTerm PRO"
set switchTo(VersaTerm\ PRO) {Internal:Comm:Versaterm:VersaTerm PRO}
addMenuItem -m switchTo "Textures"
set switchTo(Textures) {Internal:Textures:Textures}
addMenuItem -m switchTo "NCSA Telnet 2.6"
set switchTo(NCSA\ Telnet\ 2.6) {Internal:Comm:Telnet2.6 folder:NCSA Telnet 2.6}

set modeMenus(Text) { {thinkMenu} {toolserverMenu}  }
set toolserverPath "External:CodeWarrior DR/3 Gold :ToolServer 1.1.1:ToolServer"
addMenuItem -m switchTo "MacLayers v1.30"
set switchTo(MacLayers\ v1.30) {Internal:Comm:MacLayers v1.30}
set toolserverPath "External:CodeWarrior DR/3 Gold :ToolServer 1.1.1:ToolServer"
set latexPath "Internal:Textures:Textures"
set "fileSets(Project)" {Internal:Development:Alpha:EditSource:bindings.c Internal:Development:Alpha:EditSource:dir.c Internal:Development:Alpha:EditSource:dirT.c Internal:Development:Alpha:EditSource:file_set.c Internal:Development:Alpha:EditSource:fp.c Internal:Development:Alpha:EditSource:menuIcon.c Internal:Development:Alpha:EditSource:oldFullpath.c Internal:Development:Alpha:EditSource:stat.c Internal:Development:Alpha:EditSource:think.c {Internal:Development:Alpha:EditSource:Command Period.c} Internal:Development:Alpha:EditSource:localTcl.c {Internal:Development:Alpha:Tcl 7.3:tclExpr.c} Internal:Development:Alpha:EditSource:missing.c Internal:Development:Alpha:EditSource:redraw.c Internal:Development:Alpha:EditSource:text.c Internal:Development:Alpha:EditSource:varargs.c Internal:Development:Alpha:EditSource:windows.c Internal:Development:Alpha:EditSource:wmanager.c Internal:Development:Alpha:EditSource:alfRegexp.c Internal:Development:Alpha:EditSource:oldEndre.c {Internal:Development:Alpha:Tcl 7.3:panic.c} Internal:Development:Alpha:EditSource:pop.c Internal:Development:Alpha:EditSource:port.c Internal:Development:Alpha:EditSource:search.c Internal:Development:Alpha:EditSource:shell.c {Internal:Development:Alpha:Tcl 7.3:tclUtil.c} Internal:Development:Alpha:EditSource:command.c Internal:Development:Alpha:EditSource:folder.c Internal:Development:Alpha:EditSource:io.c Internal:Development:Alpha:EditSource:unixio.c Internal:Development:Alpha:EditSource:frills.c Internal:Development:Alpha:EditSource:options.c Internal:Development:Alpha:EditSource:undo.c Internal:Development:Alpha:EditSource:main.c Internal:Development:Alpha:EditSource:tclXfilescan.c Internal:Development:Alpha:EditSource:key.c Internal:Development:Alpha:EditSource:misc.c Internal:Development:Alpha:EditSource:moreTcl.c Internal:Development:Alpha:EditSource:petesTickle.c {Internal:Development:Alpha:Tcl 7.3:tclCmdMZ.c} {Internal:Development:Alpha:Tcl 7.3:regexp.c} {Internal:Development:Alpha:Tcl 7.3:tclAsync.c} {Internal:Development:Alpha:Tcl 7.3:tclBasic.c} {Internal:Development:Alpha:Tcl 7.3:tclCkalloc.c} {Internal:Development:Alpha:Tcl 7.3:tclCmdAH.c} {Internal:Development:Alpha:Tcl 7.3:tclCmdIL.c} {Internal:Development:Alpha:Tcl 7.3:tclEnv.c} Internal:Development:Alpha:EditSource:tclXhandles.c Internal:Development:Alpha:EditSource:tclXregexp.c {Internal:Development:Alpha:Tcl 7.3:MacTcl Source:macUnix.c} {Internal:Development:Alpha:Tcl 7.3:MacTcl Source:MoreFilesExtras.c} {Internal:Development:Alpha:Tcl 7.3:MacTcl Source:StringUtils.c} {Internal:Development:Alpha:Tcl 7.3:tclGet.c} {Internal:Development:Alpha:Tcl 7.3:tclHash.c} {Internal:Development:Alpha:Tcl 7.3:tclHistory.c} {Internal:Development:Alpha:Tcl 7.3:tclLink.c} {Internal:Development:Alpha:Tcl 7.3:tclMtherr.c} {Internal:Development:Alpha:Tcl 7.3:tclUnixAZ.c} {Internal:Development:Alpha:Tcl 7.3:MacTcl Source:DirectoryCopy.c} {Internal:Development:Alpha:Tcl 7.3:MacTcl Source:FileCopy.c} {Internal:Development:Alpha:Tcl 7.3:MacTcl Source:macAppInit.c} {Internal:Development:Alpha:Tcl 7.3:MacTcl Source:macEnv.c} {Internal:Development:Alpha:Tcl 7.3:MacTcl Source:macGlob.c} {Internal:Development:Alpha:Tcl 7.3:MacTcl Source:macTclRez.r} {Internal:Development:Alpha:Tcl 7.3:MacTcl Source:macUtil.c} {Internal:Development:Alpha:Tcl 7.3:MacTcl Source:MoreFiles.c} {Internal:Development:Alpha:Tcl 7.3:tclParse.c} {Internal:Development:Alpha:Tcl 7.3:tclProc.c} {Internal:Development:Alpha:Tcl 7.3:tclUnixStr.c} {Internal:Development:Alpha:Tcl 7.3:tclUnixUtil.c} {Internal:Development:Alpha:Tcl 7.3:tclVar.c} Internal:Development:Alpha:EditSource:emacs.c}
addMenuItem -m choose "Project"
set modeMenus(Text) { {thinkMenu}  }

#The next four lines add the perl mode.
set macperlPath "Internal:Development:Alpha:ae.pl"
source ":Tcl:UserCode:MacPerl.tcl"
rebuildPerlMenu
enableMenuItem install macPerl 0

addMenuItem -m switchTo "BibTeX"
set switchTo(BibTeX) {Internal:Textures:BibTeX}
set excaliburPath "Internal:Excalibur Folder:Excalibur"
set modeMenus(Tcl) { {tclMenu} {thinkMenu}  }
