
/********************************************
 **** Core Class V1.1  1993-94 Yves Schmid & Alia Development
 ****
 **** CoreErrors.h
 ****
 **** Authors:		Yves Schmid and Odorico von Susani 
 **** Created:      01 Dcembre 1993
 **** Modified:     23 July 1994
 **** Version:      0
 **** Compatible:   C++
 **** Description:  This header contains the definitions for error tracking.
 ****				When an error occurs in a Core superclass you should call
 ****				the "adderror" method. This method will send a command
 ****				CCMD_ERROR which will contain a info pointer on a CErrorInfo
 ****				structure. If you have a superclass or a linked class which
 ****				receives this kind of message you may want to handle the
 ****				problem (freeing memory for example).
 ****
 *************************/


#ifndef CoreErrors_H
#define CoreErrors_H

#define CERR_OK             0           // Ok, no errors
#define CERR_NOMEMORY       (1<<0)      // No memory
#define CERR_CANTDISPLAY    (1<<1)      // Display problem
#define CERR_CANTOPEN       (1<<2)      // Can't open
#define CERR_CANTFIND       (1<<3)      // Can't find
#define CERR_POINTERNULL    (1<<4)      // Null pointer
#define CERR_BEYONDLIMITS   (1<<5)      // Out of bounds (table, list, etc...)


struct CErrorInfo
{
    short       errorcode;
    char        *string;
};

#endif
