
/********************************************
 **** ACL-World
 ****
 **** Animmasks.cp
 ****
 **** Created:      27 August 1994
 **** Modified:     29 August 1994
 **** Version:      0
 **** Compatible:   C++, Mac System 7
 ****
 **** Description:	AnimMask demo.
 ****
 *******************/

#include "ACL-World.h"

//*************************************


static const short PICT_BACKGROUND 	= 176;
static const short PICT_PERS 		= 160;
static const short PICT_TREE_MASK	= 177;
static const short PICT_WALL_MASK	= 179;
static const short PICT_BACKGROUND2	= 180;
static const short PICT_BACKGROUND3	= 181;
static const short PICT_MONSTER 	= 156;



//*************************************

#define	TEXTSTEP1	"\pExamine the background above. The charactere should be draw behind the barrier. How could it be done?"

#define	TEXTSTEP2	"\pA solution is to put a barrier object on the background barrier. But it is not a good solution because it is very slow to draw a so big object and it uses a lot of memory."

#define	TEXTSTEP3	"\pA better solution is to build an AnimMask object which has the same shape of the barrier. AnimMask objects mask all objects which are under them using a custom shape. " \


#define	TEXTSTEP4	"\pThe sorting priority is used to know when an AnimMask is behind or in front of another Anim object. The character is masked by the AnimMask which has a higher priority than it."

#define	TEXTSTEP5	"\pNow suppose that an AnimMask is installed on the tree."

#define	TEXTSTEP6	"\pWhat happens when the charactere is in front of the tree. The priority should be modified. The tree should have a smaller priority than the charactere."

#define	TEXTSTEP7	"\pBecause AnimMasks use the sorting priority values, automatic sorting algorithms may be used to sort them. In this example, the same algorithm as the \"sorting\" demo may be used."

#define	TEXTSTEP8	"\pVisible objects and masks may be sorted with a single algorithm. Click in the picture to examine the result."

					 	
					
//*************************************

static AnimGfx	*background;
static short	backwidth,backheight;
static Anim		*anims[5];


//*************************************

Boolean ACLWorld::animmask_advance(void)
{
	short 	i,mw,mh;
	Handle 	ha;
	Rect	rect;
	AnimMask *mask;

	static short w,h;

	step++;
	
	GetDItem(dialog,1,&i,&ha,&rect);
	
	switch(step)
	{
		case 1:
		SetIText(ha,TEXTSTEP1);
		animbase->setsortflags(ASORT_PRIORITY);
		animbase->installbackground(background);
		
		anims[0] = animbase->createanim(PICT_PERS);		
		anims[0]->arrange_movehandlepoint(0,0,-1);
		anims[0]->findmaxsize(&w,&h);
		anims[0]->place((backwidth/2)-(w/2),((backheight/2)-(h/2))+h+40);
		anims[0]->arrange_moveframeoffsets(0, -(w/2), 0);
			
		return FALSE;

		case 2:
		
		delete anims[0];
		SetIText(ha,TEXTSTEP2);
		animbase->installbackground(PICT_BACKGROUND2);			
		return FALSE;

		case 3:
		SetIText(ha,TEXTSTEP3);
		animbase->installbackground(PICT_BACKGROUND3);			
		return FALSE;

		case 4:
		SetIText(ha,TEXTSTEP4);
		animbase->installbackground(background);		
		anims[0] = animbase->createanim(PICT_PERS);		
		anims[0]->arrange_movehandlepoint(0,0,-1);
		anims[0]->findmaxsize(&w,&h);
		anims[0]->place((backwidth/2)-(w/2),((backheight/2)-(h/2))+h+28);
		anims[0]->setpriority(-1);
		anims[0]->arrange_moveframeoffsets(0, -(w/2), 0);
		
		mask = animbase->createanimmask(PICT_WALL_MASK);
		mask->findcursize(&mw,&mh);
		mask->place(-1,152+mh);
		mask->setoffsety(-mh);
		return FALSE;


		case 5:
		SetIText(ha,TEXTSTEP5);		
		mask = animbase->createanimmask(PICT_TREE_MASK);
		mask->findcursize(&mw,&mh);
		mask->place(68,24+mh);
		anims[0]->place(120,60+h);
		mask->setoffsety(-mh);		
		return FALSE;

		case 6:
		SetIText(ha,TEXTSTEP6);	
		anims[0]->move(0,60);
		return FALSE;

		case 7:
		SetIText(ha,TEXTSTEP7);
		animbase->setsortflags(ASORT_BOTTOMRIGHT);		
		return FALSE;

		case 8:
		SetIText(ha,TEXTSTEP8);
	
		for(i=1;i<5;i++)
		{	
			anims[i] = animbase->createanim(PICT_MONSTER);
			anims[i]->arrange_movehandlepoint(0,0,-1);
		}
	
		anims[1]->place(75,145);
		anims[2]->place(280,200);
		anims[3]->place(78,198);
		anims[4]->place(330,185);
				
		return FALSE;
		
	}
	
	
	return TRUE;
}



//*************************************

Boolean ACLWorld::do_animmask(void)
{
	Point p;
	char  key;
	short res;
	Boolean done = FALSE;

	pleasewait(TRUE);

	animbase = new AnimBase();
	
	background = animbase->newgfx(PICT_BACKGROUND);
	animbase->newgfx(PICT_BACKGROUND2);
	animbase->newgfx(PICT_BACKGROUND3);

	animbase->newgfx(PICT_TREE_MASK);
	animbase->newgfx(PICT_WALL_MASK);

	animbase->newgfx(PICT_PERS);
	animbase->newgfx(PICT_MONSTER);


	backwidth = background->getwidth();
	backheight = background->getheight();
		
	animbase->buildbuffer(backwidth,backheight);
	animbase->setbasex(17);
	animbase->setbasey(8);


	pleasewait(FALSE);

	step = 0;
	openbasedialog();
	SetWTitle(dialog,"\pAnimMask");
	animmask_advance();

	
	for(;;)
	{
		res = processbasedialog(key,p);
		
		if 		(res==DO_QUIT) {done=TRUE; break;}
		else if (res==DO_MENU) break;
		else if (res==DO_CONTINUE && animmask_advance()) break;
		else if (res==DO_MOUSECLICK && step==8)
		{
			if (p.h<460 && p.v<217 && p.h>=0 && p.v>=0)
			{
				if (p.v<140) p.v=140;			
				anims[0]->place(p.h,p.v);
			}
		}
		
	}
	
	closebasedialog();
	
	delete animbase;

	return done;
}

//*************************************
