#include "ArrangeModule.r.h"

// MeetingMaker.r - based on GenericPlugin.r as of 7/15/94

#define ModuleName	"MeetingMaker"			// Unique module name
#define ModuleID 		0x10000005				// Unique module ID
#define ModuleRsrcID 0xFFFF8400				// Base resource ID (needn't be unique)
#define BuildDate    0							// Replace with current build date


resource ModuleDefType (ModuleRsrcID, ModuleName, preload, locked)
	{
	keepLocked,				// Module's code resources should always be locked (don't
								// lock and unlock for each call)
	loadAtBoot,				// Load the module when Arrange is launched
	ModuleName,				// Unique module name
	ModuleID,				// Unique module ID
	0x00000000,				// Module version
	BuildDate,				// Date when this module was built
	ArrangeAppID,			// Target application (Arrange)
	0x00000700,				// Target system version (7.0.0)
	ArrangePonsVers,		// Target app version (Arrange 2.0)
	0							// relative ID of root code resource
	};


// ALRT resource for our plug-in about box
resource 'ALRT' (ModuleRsrcID, purgeable)
{
	{90, 60, 210, 450},
	ModuleRsrcID,
		{	
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent
		}
#if SystemSevenOrLater
	,alertPositionMainScreen
#endif
};


// DITL resource for our plug-in about box
resource 'DITL' (ModuleRsrcID)
{
	{	
		{90, 315, 110, 375},	Button     {enabled, "OK"},
		{10,  70,  70, 370},	StaticText {disabled, "Meeting Maker file converter 1.0."},
		{10,  20,  40,  50},	Icon       {disabled, 0}
	}
};


// STR# resource IDs and indicies
#define rFieldNameStrings ModuleRsrcID
	#define rNoteTypeName 10
	
#define rMMImportExportNames ModuleRsrcID + 1
	#define rImportName 1
	#define rExportName 2


resource 'STR#' (rFieldNameStrings, purgeable) {
	{
	"Title",
	"Location",
	"Start",		//This is the day part
	"Start",		//This is the time part
	"End",		//This is really the 'duration' field, we will map it to an end date.
	"Private",
	"Flexible",
	"Label",
	"Notes",
	"Meeting" //This is the type name.
	}
};


resource 'STR#' (rMMImportExportNames, purgeable) {
	{
	"Meeting Maker", //This is the name of the import format.
	"Meeting Maker"  //This is the name of the export format.
	}
};
