/*
 *	Utilities.c
 *
 *	WASTE PROJECT
 *	General purpose utility
 *
 *	Copyright (c) 1993-1994 Marco Piovanelli
 *	All Rights Reserved
 *
 */

#ifndef __TYPES__
#include <Types.h>
#endif __TYPES__

#ifndef __MEMORY__
#include <Memory.h>
#endif __MEMORY__

#include "WASTEIntf.h"

Boolean _WEBlockCmp(register Ptr block1, register Ptr block2, register long blockSize)
{
	for ( ; blockSize > 0 ; blockSize-- )
		if ( *block1++ != *block2++ )
			return false;
	
	return true;
}

void _WEBlockClr(register Ptr block, register long blockSize)
{
	for ( ; blockSize > 0; blockSize-- )
		*block++ = 0;
}

void _WEForgetHandle(Handle *h)
{
	Handle theHandle = *h;
	
	if (theHandle != NULL)
	{
		*h = NULL;
		DisposeHandle(theHandle);
	}
}

Boolean _WESetHandleLock(Handle h, Boolean lock)
{
	Boolean oldLock = (HGetState(h) & (1 << 7)) != 0;
	
	if (lock != oldLock)
		if (lock)
			HLock(h);
		else
			HUnlock(h);
			
	return oldLock;
}

void _WEReorder(long *a, long *b)
{
	if (*a > *b)
	{
		register long temp = *a;
		*a = *b;
		*b = temp;
	}
}