/* NoteButtonImages.c */
/*****************************************************************************/
/*                                                                           */
/*    Synthesizer:  Digital Music Synthesis on General Purpose Computers     */
/*    Copyright (C) 1994  Thomas R. Lawrence                                 */
/*                                                                           */
/*    This program is free software; you can redistribute it and/or modify   */
/*    it under the terms of the GNU General Public License as published by   */
/*    the Free Software Foundation; either version 2 of the License, or      */
/*    (at your option) any later version.                                    */
/*                                                                           */
/*    This program is distributed in the hope that it will be useful,        */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/*    GNU General Public License for more details.                           */
/*                                                                           */
/*    You should have received a copy of the GNU General Public License      */
/*    along with this program; if not, write to the Free Software            */
/*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              */
/*                                                                           */
/*    Thomas R. Lawrence can be reached at tomlaw@world.std.com.             */
/*                                                                           */
/*****************************************************************************/

#include "MiscInfo.h"
#include "Audit.h"
#include "Debug.h"
#include "Definitions.h"

#define Compiling_NoteButtonImages
#include "NoteButtonImages.h"
#include "Screen.h"


EXECUTE(static MyBoolean		Initialized = False;)

Bitmap*											ArrowButtonBits;
Bitmap*											SixtyFourthButtonBits;
Bitmap*											ThirtySecondButtonBits;
Bitmap*											SixteenthButtonBits;
Bitmap*											EighthButtonBits;
Bitmap*											QuarterButtonBits;
Bitmap*											HalfButtonBits;
Bitmap*											WholeButtonBits;
Bitmap*											DoubleButtonBits;
Bitmap*											QuadButtonBits;
Bitmap*											SharpButtonBits;
Bitmap*											FlatButtonBits;
Bitmap*											NaturalButtonBits;
Bitmap*											NoteVsRestButtonBits;
Bitmap*											RestVsNoteButtonBits;
Bitmap*											NoDotButtonBits;
Bitmap*											YesDotButtonBits;
Bitmap*											Div1ButtonBits;
Bitmap*											Div3ButtonBits;
Bitmap*											Div5ButtonBits;
Bitmap*											Div7ButtonBits;
Bitmap*											CommandButtonBits;

Bitmap*											ArrowButtonMouseDownBits;
Bitmap*											SixtyFourthButtonMouseDownBits;
Bitmap*											ThirtySecondButtonMouseDownBits;
Bitmap*											SixteenthButtonMouseDownBits;
Bitmap*											EighthButtonMouseDownBits;
Bitmap*											QuarterButtonMouseDownBits;
Bitmap*											HalfButtonMouseDownBits;
Bitmap*											WholeButtonMouseDownBits;
Bitmap*											DoubleButtonMouseDownBits;
Bitmap*											QuadButtonMouseDownBits;
Bitmap*											SharpButtonMouseDownBits;
Bitmap*											FlatButtonMouseDownBits;
Bitmap*											NaturalButtonMouseDownBits;
Bitmap*											NoteVsRestButtonMouseDownBits;
Bitmap*											RestVsNoteButtonMouseDownBits;
Bitmap*											NoDotButtonMouseDownBits;
Bitmap*											YesDotButtonMouseDownBits;
Bitmap*											Div1ButtonMouseDownBits;
Bitmap*											Div3ButtonMouseDownBits;
Bitmap*											Div5ButtonMouseDownBits;
Bitmap*											Div7ButtonMouseDownBits;
Bitmap*											CommandButtonMouseDownBits;

Bitmap*											ArrowButtonSelectedBits;
Bitmap*											SixtyFourthButtonSelectedBits;
Bitmap*											ThirtySecondButtonSelectedBits;
Bitmap*											SixteenthButtonSelectedBits;
Bitmap*											EighthButtonSelectedBits;
Bitmap*											QuarterButtonSelectedBits;
Bitmap*											HalfButtonSelectedBits;
Bitmap*											WholeButtonSelectedBits;
Bitmap*											DoubleButtonSelectedBits;
Bitmap*											QuadButtonSelectedBits;
Bitmap*											SharpButtonSelectedBits;
Bitmap*											FlatButtonSelectedBits;
Bitmap*											NaturalButtonSelectedBits;
Bitmap*											NoteVsRestButtonSelectedBits;
Bitmap*											RestVsNoteButtonSelectedBits;
Bitmap*											NoDotButtonSelectedBits;
Bitmap*											YesDotButtonSelectedBits;
Bitmap*											Div1ButtonSelectedBits;
Bitmap*											Div3ButtonSelectedBits;
Bitmap*											Div5ButtonSelectedBits;
Bitmap*											Div7ButtonSelectedBits;
Bitmap*											CommandButtonSelectedBits;

Bitmap*											ArrowButtonSelectedMouseDownBits;
Bitmap*											SixtyFourthButtonSelectedMouseDownBits;
Bitmap*											ThirtySecondButtonSelectedMouseDownBits;
Bitmap*											SixteenthButtonSelectedMouseDownBits;
Bitmap*											EighthButtonSelectedMouseDownBits;
Bitmap*											QuarterButtonSelectedMouseDownBits;
Bitmap*											HalfButtonSelectedMouseDownBits;
Bitmap*											WholeButtonSelectedMouseDownBits;
Bitmap*											DoubleButtonSelectedMouseDownBits;
Bitmap*											QuadButtonSelectedMouseDownBits;
Bitmap*											SharpButtonSelectedMouseDownBits;
Bitmap*											FlatButtonSelectedMouseDownBits;
Bitmap*											NaturalButtonSelectedMouseDownBits;
Bitmap*											NoteVsRestButtonSelectedMouseDownBits;
Bitmap*											RestVsNoteButtonSelectedMouseDownBits;
Bitmap*											NoDotButtonSelectedMouseDownBits;
Bitmap*											YesDotButtonSelectedMouseDownBits;
Bitmap*											Div1ButtonSelectedMouseDownBits;
Bitmap*											Div3ButtonSelectedMouseDownBits;
Bitmap*											Div5ButtonSelectedMouseDownBits;
Bitmap*											Div7ButtonSelectedMouseDownBits;
Bitmap*											CommandButtonSelectedMouseDownBits;


static char									oArrowButton[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x80,0x01,0x80,0xC0,0x01,0x80,0xE0,0x01,
		0x80,0xF0,0x01,0x80,0xF8,0x01,0x80,0xFC,0x01,0x80,0xFE,0x01,
		0x80,0xFF,0x01,0x80,0xF8,0x01,0x80,0xD8,0x01,0x80,0x8C,0x01,
		0x80,0x0C,0x01,0x80,0x06,0x01,0x80,0x06,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oSixtyFourthButton[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x0E,0x01,0x80,0x09,0x81,0x80,0x08,0x01,0x80,0x0E,0x01,
		0x80,0x09,0x81,0x80,0x08,0x01,0x80,0x0E,0x01,0x80,0x09,0x81,
		0x80,0x08,0x01,0x80,0x0E,0x01,0x80,0x09,0x81,0x80,0x38,0x01,
		0x80,0x78,0x01,0x80,0x78,0x01,0x80,0x70,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF,
	};

static char									oThirtySecondButton[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x0E,0x01,0x80,0x09,0x81,0x80,0x08,0x01,0x80,0x0E,0x01,
		0x80,0x09,0x81,0x80,0x08,0x01,0x80,0x0E,0x01,0x80,0x09,0x81,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x38,0x01,
		0x80,0x78,0x01,0x80,0x78,0x01,0x80,0x70,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oSixteenthButton[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x0E,0x01,0x80,0x09,0x81,0x80,0x08,0x01,0x80,0x0E,0x01,
		0x80,0x09,0x81,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x38,0x01,
		0x80,0x78,0x01,0x80,0x78,0x01,0x80,0x70,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oEighthButton[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x0E,0x01,0x80,0x09,0x81,0x80,0x08,0x01,0x80,0x08,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x38,0x01,
		0x80,0x78,0x01,0x80,0x78,0x01,0x80,0x70,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oQuarterButton[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x38,0x01,
		0x80,0x78,0x01,0x80,0x78,0x01,0x80,0x70,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oHalfButton[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x38,0x01,
		0x80,0x48,0x01,0x80,0x48,0x01,0x80,0x70,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oWholeButton[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x38,0x01,
		0x80,0x48,0x01,0x80,0x48,0x01,0x80,0x70,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oDoubleButton[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x84,0x01,0x80,0xBC,0x01,
		0x80,0xCC,0x01,0x80,0xCC,0x01,0x80,0xF4,0x01,0x80,0x84,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oQuadButton[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x84,0x01,0x80,0xFC,0x01,
		0x80,0x84,0x01,0x80,0x84,0x01,0x80,0xFC,0x01,0x80,0x84,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oSharpButton[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x04,0x01,0x80,0x2E,0x01,0x80,0x74,0x01,0x80,0x24,0x01,
		0x80,0x24,0x01,0x80,0x2E,0x01,0x80,0x74,0x01,0x80,0x20,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oFlatButton[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x20,0x01,0x80,0x20,0x01,0x80,0x20,0x01,0x80,0x20,0x01,
		0x80,0x38,0x01,0x80,0x28,0x01,0x80,0x30,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oNaturalButton[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x20,0x01,0x80,0x2C,0x01,0x80,0x34,0x01,0x80,0x24,0x01,
		0x80,0x24,0x01,0x80,0x2C,0x01,0x80,0x34,0x01,0x80,0x04,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oNoteVsRestButton[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x38,0x01,
		0x80,0x78,0x01,0x80,0x78,0x01,0x80,0x70,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oRestVsNoteButton[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x40,0x01,
		0x80,0x30,0x01,0x80,0x18,0x01,0x80,0x18,0x01,0x80,0x30,0x01,
		0x80,0x30,0x01,0x80,0x18,0x01,0x80,0x34,0x01,0x80,0x60,0x01,
		0x80,0x60,0x01,0x80,0x30,0x01,0x80,0x08,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oNoDotButton[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x38,0x01,
		0x80,0x78,0x01,0x80,0x78,0x01,0x80,0x70,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oYesDotButton[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x38,0x01,
		0x80,0x78,0xC1,0x80,0x78,0xC1,0x80,0x70,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oDiv1Button[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x38,0x01,
		0x80,0x78,0x01,0x80,0x78,0x01,0x80,0x70,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oDiv3Button[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x08,0x01,0x87,0x08,0x01,0x81,0x88,0x01,0x81,0x88,0x01,
		0x87,0x08,0x01,0x81,0x88,0x01,0x81,0x88,0x01,0x87,0x08,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x38,0x01,
		0x80,0x78,0x01,0x80,0x78,0x01,0x80,0x70,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oDiv5Button[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x08,0x01,0x87,0x88,0x01,0x86,0x08,0x01,0x86,0x08,0x01,
		0x87,0x08,0x01,0x81,0x88,0x01,0x81,0x88,0x01,0x87,0x08,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x38,0x01,
		0x80,0x78,0x01,0x80,0x78,0x01,0x80,0x70,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oDiv7Button[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x08,0x01,0x87,0x88,0x01,0x81,0x88,0x01,0x81,0x88,0x01,
		0x83,0x08,0x01,0x83,0x08,0x01,0x86,0x08,0x01,0x86,0x08,0x01,
		0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x08,0x01,0x80,0x38,0x01,
		0x80,0x78,0x01,0x80,0x78,0x01,0x80,0x70,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oCommandButton[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x8F,0xFF,0xF1,0x88,0x00,0x11,0x8B,0xC6,0x11,
		0x88,0x00,0x11,0x8B,0x67,0x11,0x88,0x00,0x11,0x8A,0xDF,0x11,
		0x88,0x00,0x11,0x8F,0xFF,0xF1,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,
		0x80,0x00,0x01,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};


static char									oArrowButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xE0,0x80,0x07,0xE0,0xC0,0x07,0xE0,0xE0,0x07,
		0xE0,0xF0,0x07,0xE0,0xF8,0x07,0xE0,0xFC,0x07,0xE0,0xFE,0x07,
		0xE0,0xFF,0x07,0xE0,0xF8,0x07,0xE0,0xD8,0x07,0xE0,0x8C,0x07,
		0xE0,0x0C,0x07,0xE0,0x06,0x07,0xE0,0x06,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oSixtyFourthButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x0E,0x07,0xE0,0x09,0x87,0xE0,0x08,0x07,0xE0,0x0E,0x07,
		0xE0,0x09,0x87,0xE0,0x08,0x07,0xE0,0x0E,0x07,0xE0,0x09,0x87,
		0xE0,0x08,0x07,0xE0,0x0E,0x07,0xE0,0x09,0x87,0xE0,0x38,0x07,
		0xE0,0x78,0x07,0xE0,0x78,0x07,0xE0,0x70,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oThirtySecondButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x0E,0x07,0xE0,0x09,0x87,0xE0,0x08,0x07,0xE0,0x0E,0x07,
		0xE0,0x09,0x87,0xE0,0x08,0x07,0xE0,0x0E,0x07,0xE0,0x09,0x87,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x38,0x07,
		0xE0,0x78,0x07,0xE0,0x78,0x07,0xE0,0x70,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oSixteenthButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x0E,0x07,0xE0,0x09,0x87,0xE0,0x08,0x07,0xE0,0x0E,0x07,
		0xE0,0x09,0x87,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x38,0x07,
		0xE0,0x78,0x07,0xE0,0x78,0x07,0xE0,0x70,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oEighthButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x0E,0x07,0xE0,0x09,0x87,0xE0,0x08,0x07,0xE0,0x08,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x38,0x07,
		0xE0,0x78,0x07,0xE0,0x78,0x07,0xE0,0x70,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oQuarterButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x38,0x07,
		0xE0,0x78,0x07,0xE0,0x78,0x07,0xE0,0x70,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oHalfButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x38,0x07,
		0xE0,0x48,0x07,0xE0,0x48,0x07,0xE0,0x70,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oWholeButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x38,0x07,
		0xE0,0x48,0x07,0xE0,0x48,0x07,0xE0,0x70,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oDoubleButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x84,0x07,0xE0,0xBC,0x07,
		0xE0,0xCC,0x07,0xE0,0xCC,0x07,0xE0,0xF4,0x07,0xE0,0x84,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oQuadButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x84,0x07,0xE0,0xFC,0x07,
		0xE0,0x84,0x07,0xE0,0x84,0x07,0xE0,0xFC,0x07,0xE0,0x84,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oSharpButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,
		0xE0,0x04,0x07,0xE0,0x2E,0x07,0xE0,0x74,0x07,0xE0,0x24,0x07,
		0xE0,0x24,0x07,0xE0,0x2E,0x07,0xE0,0x74,0x07,0xE0,0x20,0x07,
		0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oFlatButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,
		0xE0,0x20,0x07,0xE0,0x20,0x07,0xE0,0x20,0x07,0xE0,0x20,0x07,
		0xE0,0x38,0x07,0xE0,0x28,0x07,0xE0,0x30,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oNaturalButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,
		0xE0,0x20,0x07,0xE0,0x2C,0x07,0xE0,0x34,0x07,0xE0,0x24,0x07,
		0xE0,0x24,0x07,0xE0,0x2C,0x07,0xE0,0x34,0x07,0xE0,0x04,0x07,
		0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oNoteVsRestButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x38,0x07,
		0xE0,0x78,0x07,0xE0,0x78,0x07,0xE0,0x70,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oRestVsNoteButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x40,0x07,
		0xE0,0x30,0x07,0xE0,0x18,0x07,0xE0,0x18,0x07,0xE0,0x30,0x07,
		0xE0,0x30,0x07,0xE0,0x18,0x07,0xE0,0x34,0x07,0xE0,0x60,0x07,
		0xE0,0x60,0x07,0xE0,0x30,0x07,0xE0,0x08,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oNoDotButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x38,0x07,
		0xE0,0x78,0x07,0xE0,0x78,0x07,0xE0,0x70,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oYesDotButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x38,0x07,
		0xE0,0x78,0xC7,0xE0,0x78,0xC7,0xE0,0x70,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oDiv1ButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x38,0x07,
		0xE0,0x78,0x07,0xE0,0x78,0x07,0xE0,0x70,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oDiv3ButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x08,0x07,0xE7,0x08,0x07,0xE1,0x88,0x07,0xE1,0x88,0x07,
		0xE7,0x08,0x07,0xE1,0x88,0x07,0xE1,0x88,0x07,0xE7,0x08,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x38,0x07,
		0xE0,0x78,0x07,0xE0,0x78,0x07,0xE0,0x70,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oDiv5ButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x08,0x07,0xE7,0x88,0x07,0xE6,0x08,0x07,0xE6,0x08,0x07,
		0xE7,0x08,0x07,0xE1,0x88,0x07,0xE1,0x88,0x07,0xE7,0x08,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x38,0x07,
		0xE0,0x78,0x07,0xE0,0x78,0x07,0xE0,0x70,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oDiv7ButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x08,0x07,0xE7,0x88,0x07,0xE1,0x88,0x07,0xE1,0x88,0x07,
		0xE3,0x08,0x07,0xE3,0x08,0x07,0xE6,0x08,0x07,0xE6,0x08,0x07,
		0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x08,0x07,0xE0,0x38,0x07,
		0xE0,0x78,0x07,0xE0,0x78,0x07,0xE0,0x70,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oCommandButtonMouseDown[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xEF,0xFF,0xF7,0xE8,0x00,0x17,0xEB,0xC6,0x17,
		0xE8,0x00,0x17,0xEB,0x67,0x17,0xE8,0x00,0x17,0xEA,0xDF,0x17,
		0xE8,0x00,0x17,0xEF,0xFF,0xF7,0xE0,0x00,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,0xE0,0x00,0x07,
		0xE0,0x00,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};


static char									oArrowButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0x7F,0xFF,0xFF,0x3F,0xFF,0xFF,0x1F,0xFF,
		0xFF,0x0F,0xFF,0xFF,0x07,0xFF,0xFF,0x03,0xFF,0xFF,0x01,0xFF,
		0xFF,0x00,0xFF,0xFF,0x07,0xFF,0xFF,0x27,0xFF,0xFF,0x73,0xFF,
		0xFF,0xF3,0xFF,0xFF,0xF9,0xFF,0xFF,0xF9,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oSixtyFourthButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xF1,0xFF,0xFF,0xF6,0x7F,0xFF,0xF7,0xFF,0xFF,0xF1,0xFF,
		0xFF,0xF6,0x7F,0xFF,0xF7,0xFF,0xFF,0xF1,0xFF,0xFF,0xF6,0x7F,
		0xFF,0xF7,0xFF,0xFF,0xF1,0xFF,0xFF,0xF6,0x7F,0xFF,0xC7,0xFF,
		0xFF,0x87,0xFF,0xFF,0x87,0xFF,0xFF,0x8F,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oThirtySecondButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xF1,0xFF,0xFF,0xF6,0x7F,0xFF,0xF7,0xFF,0xFF,0xF1,0xFF,
		0xFF,0xF6,0x7F,0xFF,0xF7,0xFF,0xFF,0xF1,0xFF,0xFF,0xF6,0x7F,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xC7,0xFF,
		0xFF,0x87,0xFF,0xFF,0x87,0xFF,0xFF,0x8F,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oSixteenthButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xF1,0xFF,0xFF,0xF6,0x7F,0xFF,0xF7,0xFF,0xFF,0xF1,0xFF,
		0xFF,0xF6,0x7F,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xC7,0xFF,
		0xFF,0x87,0xFF,0xFF,0x87,0xFF,0xFF,0x8F,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oEighthButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xF1,0xFF,0xFF,0xF6,0x7F,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xC7,0xFF,
		0xFF,0x87,0xFF,0xFF,0x87,0xFF,0xFF,0x8F,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oQuarterButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xC7,0xFF,
		0xFF,0x87,0xFF,0xFF,0x87,0xFF,0xFF,0x8F,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oHalfButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xC7,0xFF,
		0xFF,0xB7,0xFF,0xFF,0xB7,0xFF,0xFF,0x8F,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oWholeButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC7,0xFF,
		0xFF,0xB7,0xFF,0xFF,0xB7,0xFF,0xFF,0x8F,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oDoubleButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x7B,0xFF,0xFF,0x43,0xFF,
		0xFF,0x33,0xFF,0xFF,0x33,0xFF,0xFF,0x0B,0xFF,0xFF,0x7B,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oQuadButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x7B,0xFF,0xFF,0x03,0xFF,
		0xFF,0x7B,0xFF,0xFF,0x7B,0xFF,0xFF,0x03,0xFF,0xFF,0x7B,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oSharpButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFB,0xFF,0xFF,0xD1,0xFF,0xFF,0x8B,0xFF,0xFF,0xDB,0xFF,
		0xFF,0xDB,0xFF,0xFF,0xD1,0xFF,0xFF,0x8B,0xFF,0xFF,0xDF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oFlatButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xDF,0xFF,0xFF,0xDF,0xFF,0xFF,0xDF,0xFF,0xFF,0xDF,0xFF,
		0xFF,0xC7,0xFF,0xFF,0xD7,0xFF,0xFF,0xCF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oNaturalButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xDF,0xFF,0xFF,0xD3,0xFF,0xFF,0xCB,0xFF,0xFF,0xDB,0xFF,
		0xFF,0xDB,0xFF,0xFF,0xD3,0xFF,0xFF,0xCB,0xFF,0xFF,0xFB,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oNoteVsRestButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xC7,0xFF,
		0xFF,0x87,0xFF,0xFF,0x87,0xFF,0xFF,0x8F,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oRestVsNoteButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xBF,0xFF,
		0xFF,0xCF,0xFF,0xFF,0xE7,0xFF,0xFF,0xE7,0xFF,0xFF,0xCF,0xFF,
		0xFF,0xCF,0xFF,0xFF,0xE7,0xFF,0xFF,0xCB,0xFF,0xFF,0x9F,0xFF,
		0xFF,0x9F,0xFF,0xFF,0xCF,0xFF,0xFF,0xF7,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oNoDotButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xC7,0xFF,
		0xFF,0x87,0xFF,0xFF,0x87,0xFF,0xFF,0x8F,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oYesDotButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xC7,0xFF,
		0xFF,0x87,0x3F,0xFF,0x87,0x3F,0xFF,0x8F,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oDiv1ButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xC7,0xFF,
		0xFF,0x87,0xFF,0xFF,0x87,0xFF,0xFF,0x8F,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oDiv3ButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xF7,0xFF,0xF8,0xF7,0xFF,0xFE,0x77,0xFF,0xFE,0x77,0xFF,
		0xF8,0xF7,0xFF,0xFE,0x77,0xFF,0xFE,0x77,0xFF,0xF8,0xF7,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xC7,0xFF,
		0xFF,0x87,0xFF,0xFF,0x87,0xFF,0xFF,0x8F,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oDiv5ButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xF7,0xFF,0xF8,0x77,0xFF,0xF9,0xF7,0xFF,0xF9,0xF7,0xFF,
		0xF8,0xF7,0xFF,0xFE,0x77,0xFF,0xFE,0x77,0xFF,0xF8,0xF7,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xC7,0xFF,
		0xFF,0x87,0xFF,0xFF,0x87,0xFF,0xFF,0x8F,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oDiv7ButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xF7,0xFF,0xF8,0x77,0xFF,0xFE,0x77,0xFF,0xFE,0x77,0xFF,
		0xFC,0xF7,0xFF,0xFC,0xF7,0xFF,0xF9,0xF7,0xFF,0xF9,0xF7,0xFF,
		0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xF7,0xFF,0xFF,0xC7,0xFF,
		0xFF,0x87,0xFF,0xFF,0x87,0xFF,0xFF,0x8F,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};

static char									oCommandButtonSelected[] =
	{
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xF0,0x00,0x0F,0xF7,0xFF,0xEF,0xF4,0x39,0xEF,
		0xF7,0xFF,0xEF,0xF4,0x98,0xEF,0xF7,0xFF,0xEF,0xF5,0x20,0xEF,
		0xF7,0xFF,0xEF,0xF0,0x00,0x0F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	};


static char									oArrowButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x9F,0x7F,0xF9,0x9F,0x3F,0xF9,0x9F,0x1F,0xF9,
		0x9F,0x0F,0xF9,0x9F,0x07,0xF9,0x9F,0x03,0xF9,0x9F,0x01,0xF9,
		0x9F,0x00,0xF9,0x9F,0x07,0xF9,0x9F,0x27,0xF9,0x9F,0x73,0xF9,
		0x9F,0xF3,0xF9,0x9F,0xF9,0xF9,0x9F,0xF9,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oSixtyFourthButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xF1,0xF9,0x9F,0xF6,0x79,0x9F,0xF7,0xF9,0x9F,0xF1,0xF9,
		0x9F,0xF6,0x79,0x9F,0xF7,0xF9,0x9F,0xF1,0xF9,0x9F,0xF6,0x79,
		0x9F,0xF7,0xF9,0x9F,0xF1,0xF9,0x9F,0xF6,0x79,0x9F,0xC7,0xF9,
		0x9F,0x87,0xF9,0x9F,0x87,0xF9,0x9F,0x8F,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oThirtySecondButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xF1,0xF9,0x9F,0xF6,0x79,0x9F,0xF7,0xF9,0x9F,0xF1,0xF9,
		0x9F,0xF6,0x79,0x9F,0xF7,0xF9,0x9F,0xF1,0xF9,0x9F,0xF6,0x79,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xC7,0xF9,
		0x9F,0x87,0xF9,0x9F,0x87,0xF9,0x9F,0x8F,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oSixteenthButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xF1,0xF9,0x9F,0xF6,0x79,0x9F,0xF7,0xF9,0x9F,0xF1,0xF9,
		0x9F,0xF6,0x79,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xC7,0xF9,
		0x9F,0x87,0xF9,0x9F,0x87,0xF9,0x9F,0x8F,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oEighthButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xF1,0xF9,0x9F,0xF6,0x79,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xC7,0xF9,
		0x9F,0x87,0xF9,0x9F,0x87,0xF9,0x9F,0x8F,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oQuarterButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xC7,0xF9,
		0x9F,0x87,0xF9,0x9F,0x87,0xF9,0x9F,0x8F,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oHalfButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xC7,0xF9,
		0x9F,0xB7,0xF9,0x9F,0xB7,0xF9,0x9F,0x8F,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oWholeButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xC7,0xF9,
		0x9F,0xB7,0xF9,0x9F,0xB7,0xF9,0x9F,0x8F,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oDoubleButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0x7B,0xF9,0x9F,0x43,0xF9,
		0x9F,0x33,0xF9,0x9F,0x33,0xF9,0x9F,0x0B,0xF9,0x9F,0x7B,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oQuadButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0x7B,0xF9,0x9F,0x03,0xF9,
		0x9F,0x7B,0xF9,0x9F,0x7B,0xF9,0x9F,0x03,0xF9,0x9F,0x7B,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oSharpButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFB,0xF9,0x9F,0xD1,0xF9,0x9F,0x8B,0xF9,0x9F,0xDB,0xF9,
		0x9F,0xDB,0xF9,0x9F,0xD1,0xF9,0x9F,0x8B,0xF9,0x9F,0xDF,0xF9,
		0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oFlatButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xDF,0xF9,0x9F,0xDF,0xF9,0x9F,0xDF,0xF9,0x9F,0xDF,0xF9,
		0x9F,0xC7,0xF9,0x9F,0xD7,0xF9,0x9F,0xCF,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oNaturalButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xDF,0xF9,0x9F,0xD3,0xF9,0x9F,0xCB,0xF9,0x9F,0xDB,0xF9,
		0x9F,0xDB,0xF9,0x9F,0xD3,0xF9,0x9F,0xCB,0xF9,0x9F,0xFB,0xF9,
		0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oNoteVsRestButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xC7,0xF9,
		0x9F,0x87,0xF9,0x9F,0x87,0xF9,0x9F,0x8F,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oRestVsNoteButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xBF,0xF9,
		0x9F,0xCF,0xF9,0x9F,0xE7,0xF9,0x9F,0xE7,0xF9,0x9F,0xCF,0xF9,
		0x9F,0xCF,0xF9,0x9F,0xE7,0xF9,0x9F,0xCB,0xF9,0x9F,0x9F,0xF9,
		0x9F,0x9F,0xF9,0x9F,0xCF,0xF9,0x9F,0xF7,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oNoDotButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xC7,0xF9,
		0x9F,0x87,0xF9,0x9F,0x87,0xF9,0x9F,0x8F,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oYesDotButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xC7,0xF9,
		0x9F,0x87,0x39,0x9F,0x87,0x39,0x9F,0x8F,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oDiv1ButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xC7,0xF9,
		0x9F,0x87,0xF9,0x9F,0x87,0xF9,0x9F,0x8F,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oDiv3ButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xF7,0xF9,0x98,0xF7,0xF9,0x9E,0x77,0xF9,0x9E,0x77,0xF9,
		0x98,0xF7,0xF9,0x9E,0x77,0xF9,0x9E,0x77,0xF9,0x98,0xF7,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xC7,0xF9,
		0x9F,0x87,0xF9,0x9F,0x87,0xF9,0x9F,0x8F,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oDiv5ButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xF7,0xF9,0x98,0x77,0xF9,0x99,0xF7,0xF9,0x99,0xF7,0xF9,
		0x98,0xF7,0xF9,0x9E,0x77,0xF9,0x9E,0x77,0xF9,0x98,0xF7,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xC7,0xF9,
		0x9F,0x87,0xF9,0x9F,0x87,0xF9,0x9F,0x8F,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oDiv7ButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xF7,0xF9,0x98,0x77,0xF9,0x9E,0x77,0xF9,0x9E,0x77,0xF9,
		0x9C,0xF7,0xF9,0x9C,0xF7,0xF9,0x99,0xF7,0xF9,0x99,0xF7,0xF9,
		0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xF7,0xF9,0x9F,0xC7,0xF9,
		0x9F,0x87,0xF9,0x9F,0x87,0xF9,0x9F,0x8F,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};

static char									oCommandButtonSelectedMouseDown[] =
	{
		0xFF,0xFF,0xFF,0x80,0x00,0x01,0x80,0x00,0x01,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x90,0x00,0x09,0x97,0xFF,0xE9,0x94,0x39,0xE9,
		0x97,0xFF,0xE9,0x94,0x98,0xE9,0x97,0xFF,0xE9,0x95,0x20,0xE9,
		0x97,0xFF,0xE9,0x90,0x00,0x09,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,0x9F,0xFF,0xF9,
		0x9F,0xFF,0xF9,0x80,0x00,0x01,0x80,0x00,0x01,0xFF,0xFF,0xFF
	};


MyBoolean						InitializeNoteButtonImages(void)
	{
		ERROR(Initialized,PRERR(ForceAbort,"InitializeNoteButtonImages:  already initialized"));
		EXECUTE(Initialized = True;)
		/* we do not watch for out of memory conditions because this should be */
		/* called early when there is plenty of memory available */
		ArrowButtonBits = MakeBitmap(oArrowButton,24,24,3);
		if (ArrowButtonBits == NIL)
			{
			 FailurePoint1:
				return False;
			}
		SixtyFourthButtonBits = MakeBitmap(oSixtyFourthButton,24,24,3);
		if (SixtyFourthButtonBits == NIL)
			{
			 FailurePoint2:
				DisposeBitmap(ArrowButtonBits);
				goto FailurePoint1;
			}
		ThirtySecondButtonBits = MakeBitmap(oThirtySecondButton,24,24,3);
		if (ThirtySecondButtonBits == NIL)
			{
			 FailurePoint3:
				DisposeBitmap(SixtyFourthButtonBits);
				goto FailurePoint2;
			}
		SixteenthButtonBits = MakeBitmap(oSixteenthButton,24,24,3);
		if (SixteenthButtonBits == NIL)
			{
			 FailurePoint4:
				DisposeBitmap(ThirtySecondButtonBits);
				goto FailurePoint3;
			}
		EighthButtonBits = MakeBitmap(oEighthButton,24,24,3);
		if (EighthButtonBits == NIL)
			{
			 FailurePoint5:
				DisposeBitmap(SixteenthButtonBits);
				goto FailurePoint4;
			}
		QuarterButtonBits = MakeBitmap(oQuarterButton,24,24,3);
		if (QuarterButtonBits == NIL)
			{
			 FailurePoint6:
				DisposeBitmap(EighthButtonBits);
				goto FailurePoint5;
			}
		HalfButtonBits = MakeBitmap(oHalfButton,24,24,3);
		if (HalfButtonBits == NIL)
			{
			 FailurePoint7:
				DisposeBitmap(QuarterButtonBits);
				goto FailurePoint6;
			}
		WholeButtonBits = MakeBitmap(oWholeButton,24,24,3);
		if (WholeButtonBits == NIL)
			{
			 FailurePoint8:
				DisposeBitmap(HalfButtonBits);
				goto FailurePoint7;
			}
		DoubleButtonBits = MakeBitmap(oDoubleButton,24,24,3);
		if (DoubleButtonBits == NIL)
			{
			 FailurePoint9:
				DisposeBitmap(WholeButtonBits);
				goto FailurePoint8;
			}
		QuadButtonBits = MakeBitmap(oQuadButton,24,24,3);
		if (QuadButtonBits == NIL)
			{
			 FailurePoint10:
				DisposeBitmap(DoubleButtonBits);
				goto FailurePoint9;
			}
		SharpButtonBits = MakeBitmap(oSharpButton,24,24,3);
		if (SharpButtonBits == NIL)
			{
			 FailurePoint11:
				DisposeBitmap(QuadButtonBits);
				goto FailurePoint10;
			}
		FlatButtonBits = MakeBitmap(oFlatButton,24,24,3);
		if (FlatButtonBits == NIL)
			{
			 FailurePoint12:
				DisposeBitmap(SharpButtonBits);
				goto FailurePoint11;
			}
		NaturalButtonBits = MakeBitmap(oNaturalButton,24,24,3);
		if (NaturalButtonBits == NIL)
			{
			 FailurePoint13:
				DisposeBitmap(FlatButtonBits);
				goto FailurePoint12;
			}
		NoteVsRestButtonBits = MakeBitmap(oNoteVsRestButton,24,24,3);
		if (NoteVsRestButtonBits == NIL)
			{
			 FailurePoint14:
				DisposeBitmap(NaturalButtonBits);
				goto FailurePoint13;
			}
		RestVsNoteButtonBits = MakeBitmap(oRestVsNoteButton,24,24,3);
		if (RestVsNoteButtonBits == NIL)
			{
			 FailurePoint15:
				DisposeBitmap(NoteVsRestButtonBits);
				goto FailurePoint14;
			}
		NoDotButtonBits = MakeBitmap(oNoDotButton,24,24,3);
		if (NoDotButtonBits == NIL)
			{
			 FailurePoint16:
				DisposeBitmap(RestVsNoteButtonBits);
				goto FailurePoint15;
			}
		YesDotButtonBits = MakeBitmap(oYesDotButton,24,24,3);
		if (YesDotButtonBits == NIL)
			{
			 FailurePoint17:
				DisposeBitmap(NoDotButtonBits);
				goto FailurePoint16;
			}
		Div1ButtonBits = MakeBitmap(oDiv1Button,24,24,3);
		if (Div1ButtonBits == NIL)
			{
			 FailurePoint18:
				DisposeBitmap(YesDotButtonBits);
				goto FailurePoint17;
			}
		Div3ButtonBits = MakeBitmap(oDiv3Button,24,24,3);
		if (Div3ButtonBits == NIL)
			{
			 FailurePoint19:
				DisposeBitmap(Div1ButtonBits);
				goto FailurePoint18;
			}
		Div5ButtonBits = MakeBitmap(oDiv5Button,24,24,3);
		if (Div5ButtonBits == NIL)
			{
			 FailurePoint20:
				DisposeBitmap(Div3ButtonBits);
				goto FailurePoint19;
			}
		Div7ButtonBits = MakeBitmap(oDiv7Button,24,24,3);
		if (Div7ButtonBits == NIL)
			{
			 FailurePoint21:
				DisposeBitmap(Div5ButtonBits);
				goto FailurePoint20;
			}

		ArrowButtonMouseDownBits = MakeBitmap(oArrowButtonMouseDown,24,24,3);
		if (ArrowButtonMouseDownBits == NIL)
			{
			 FailurePoint22:
				DisposeBitmap(Div7ButtonBits);
				goto FailurePoint21;
			}
		SixtyFourthButtonMouseDownBits = MakeBitmap(oSixtyFourthButtonMouseDown,24,24,3);
		if (SixtyFourthButtonMouseDownBits == NIL)
			{
			 FailurePoint23:
				DisposeBitmap(ArrowButtonMouseDownBits);
				goto FailurePoint22;
			}
		ThirtySecondButtonMouseDownBits = MakeBitmap(oThirtySecondButtonMouseDown,24,24,3);
		if (ThirtySecondButtonMouseDownBits == NIL)
			{
			 FailurePoint24:
				DisposeBitmap(SixtyFourthButtonMouseDownBits);
				goto FailurePoint23;
			}
		SixteenthButtonMouseDownBits = MakeBitmap(oSixteenthButtonMouseDown,24,24,3);
		if (SixteenthButtonMouseDownBits == NIL)
			{
			 FailurePoint25:
				DisposeBitmap(ThirtySecondButtonMouseDownBits);
				goto FailurePoint24;
			}
		EighthButtonMouseDownBits = MakeBitmap(oEighthButtonMouseDown,24,24,3);
		if (EighthButtonMouseDownBits == NIL)
			{
			 FailurePoint26:
				DisposeBitmap(SixteenthButtonMouseDownBits);
				goto FailurePoint25;
			}
		QuarterButtonMouseDownBits = MakeBitmap(oQuarterButtonMouseDown,24,24,3);
		if (QuarterButtonMouseDownBits == NIL)
			{
			 FailurePoint27:
				DisposeBitmap(EighthButtonMouseDownBits);
				goto FailurePoint26;
			}
		HalfButtonMouseDownBits = MakeBitmap(oHalfButtonMouseDown,24,24,3);
		if (HalfButtonMouseDownBits == NIL)
			{
			 FailurePoint28:
				DisposeBitmap(QuarterButtonMouseDownBits);
				goto FailurePoint27;
			}
		WholeButtonMouseDownBits = MakeBitmap(oWholeButtonMouseDown,24,24,3);
		if (WholeButtonMouseDownBits == NIL)
			{
			 FailurePoint29:
				DisposeBitmap(HalfButtonMouseDownBits);
				goto FailurePoint28;
			}
		DoubleButtonMouseDownBits = MakeBitmap(oDoubleButtonMouseDown,24,24,3);
		if (DoubleButtonMouseDownBits == NIL)
			{
			 FailurePoint30:
				DisposeBitmap(WholeButtonMouseDownBits);
				goto FailurePoint29;
			}
		QuadButtonMouseDownBits = MakeBitmap(oQuadButtonMouseDown,24,24,3);
		if (QuadButtonMouseDownBits == NIL)
			{
			 FailurePoint31:
				DisposeBitmap(DoubleButtonMouseDownBits);
				goto FailurePoint30;
			}
		SharpButtonMouseDownBits = MakeBitmap(oSharpButtonMouseDown,24,24,3);
		if (SharpButtonMouseDownBits == NIL)
			{
			 FailurePoint32:
				DisposeBitmap(QuadButtonMouseDownBits);
				goto FailurePoint31;
			}
		FlatButtonMouseDownBits = MakeBitmap(oFlatButtonMouseDown,24,24,3);
		if (FlatButtonMouseDownBits == NIL)
			{
			 FailurePoint33:
				DisposeBitmap(SharpButtonMouseDownBits);
				goto FailurePoint32;
			}
		NaturalButtonMouseDownBits = MakeBitmap(oNaturalButtonMouseDown,24,24,3);
		if (NaturalButtonMouseDownBits == NIL)
			{
			 FailurePoint34:
				DisposeBitmap(FlatButtonMouseDownBits);
				goto FailurePoint33;
			}
		NoteVsRestButtonMouseDownBits = MakeBitmap(oNoteVsRestButtonMouseDown,24,24,3);
		if (NoteVsRestButtonMouseDownBits == NIL)
			{
			 FailurePoint35:
				DisposeBitmap(NaturalButtonMouseDownBits);
				goto FailurePoint34;
			}
		RestVsNoteButtonMouseDownBits = MakeBitmap(oRestVsNoteButtonMouseDown,24,24,3);
		if (RestVsNoteButtonMouseDownBits == NIL)
			{
			 FailurePoint36:
				DisposeBitmap(NoteVsRestButtonMouseDownBits);
				goto FailurePoint35;
			}
		NoDotButtonMouseDownBits = MakeBitmap(oNoDotButtonMouseDown,24,24,3);
		if (NoDotButtonMouseDownBits == NIL)
			{
			 FailurePoint37:
				DisposeBitmap(RestVsNoteButtonMouseDownBits);
				goto FailurePoint36;
			}
		YesDotButtonMouseDownBits = MakeBitmap(oYesDotButtonMouseDown,24,24,3);
		if (YesDotButtonMouseDownBits == NIL)
			{
			 FailurePoint38:
				DisposeBitmap(NoDotButtonMouseDownBits);
				goto FailurePoint37;
			}
		Div1ButtonMouseDownBits = MakeBitmap(oDiv1ButtonMouseDown,24,24,3);
		if (Div1ButtonMouseDownBits == NIL)
			{
			 FailurePoint39:
				DisposeBitmap(YesDotButtonMouseDownBits);
				goto FailurePoint38;
			}
		Div3ButtonMouseDownBits = MakeBitmap(oDiv3ButtonMouseDown,24,24,3);
		if (Div3ButtonMouseDownBits == NIL)
			{
			 FailurePoint40:
				DisposeBitmap(Div1ButtonMouseDownBits);
				goto FailurePoint39;
			}
		Div5ButtonMouseDownBits = MakeBitmap(oDiv5ButtonMouseDown,24,24,3);
		if (Div5ButtonMouseDownBits == NIL)
			{
			 FailurePoint41:
				DisposeBitmap(Div3ButtonMouseDownBits);
				goto FailurePoint40;
			}
		Div7ButtonMouseDownBits = MakeBitmap(oDiv7ButtonMouseDown,24,24,3);
		if (Div7ButtonMouseDownBits == NIL)
			{
			 FailurePoint42:
				DisposeBitmap(Div5ButtonMouseDownBits);
				goto FailurePoint41;
			}

		ArrowButtonSelectedBits = MakeBitmap(oArrowButtonSelected,24,24,3);
		if (ArrowButtonSelectedBits == NIL)
			{
			 FailurePoint43:
				DisposeBitmap(Div7ButtonMouseDownBits);
				goto FailurePoint42;
			}
		SixtyFourthButtonSelectedBits = MakeBitmap(oSixtyFourthButtonSelected,24,24,3);
		if (SixtyFourthButtonSelectedBits == NIL)
			{
			 FailurePoint44:
				DisposeBitmap(ArrowButtonSelectedBits);
				goto FailurePoint43;
			}
		ThirtySecondButtonSelectedBits = MakeBitmap(oThirtySecondButtonSelected,24,24,3);
		if (ThirtySecondButtonSelectedBits == NIL)
			{
			 FailurePoint45:
				DisposeBitmap(SixtyFourthButtonSelectedBits);
				goto FailurePoint44;
			}
		SixteenthButtonSelectedBits = MakeBitmap(oSixteenthButtonSelected,24,24,3);
		if (SixteenthButtonSelectedBits == NIL)
			{
			 FailurePoint46:
				DisposeBitmap(ThirtySecondButtonSelectedBits);
				goto FailurePoint45;
			}
		EighthButtonSelectedBits = MakeBitmap(oEighthButtonSelected,24,24,3);
		if (EighthButtonSelectedBits == NIL)
			{
			 FailurePoint47:
				DisposeBitmap(SixteenthButtonSelectedBits);
				goto FailurePoint46;
			}
		QuarterButtonSelectedBits = MakeBitmap(oQuarterButtonSelected,24,24,3);
		if (QuarterButtonSelectedBits == NIL)
			{
			 FailurePoint48:
				DisposeBitmap(EighthButtonSelectedBits);
				goto FailurePoint47;
			}
		HalfButtonSelectedBits = MakeBitmap(oHalfButtonSelected,24,24,3);
		if (HalfButtonSelectedBits == NIL)
			{
			 FailurePoint49:
				DisposeBitmap(QuarterButtonSelectedBits);
				goto FailurePoint48;
			}
		WholeButtonSelectedBits = MakeBitmap(oWholeButtonSelected,24,24,3);
		if (WholeButtonSelectedBits == NIL)
			{
			 FailurePoint50:
				DisposeBitmap(HalfButtonSelectedBits);
				goto FailurePoint49;
			}
		DoubleButtonSelectedBits = MakeBitmap(oDoubleButtonSelected,24,24,3);
		if (DoubleButtonSelectedBits == NIL)
			{
			 FailurePoint51:
				DisposeBitmap(WholeButtonSelectedBits);
				goto FailurePoint50;
			}
		QuadButtonSelectedBits = MakeBitmap(oQuadButtonSelected,24,24,3);
		if (QuadButtonSelectedBits == NIL)
			{
			 FailurePoint52:
				DisposeBitmap(DoubleButtonSelectedBits);
				goto FailurePoint51;
			}
		SharpButtonSelectedBits = MakeBitmap(oSharpButtonSelected,24,24,3);
		if (SharpButtonSelectedBits == NIL)
			{
			 FailurePoint53:
				DisposeBitmap(QuadButtonSelectedBits);
				goto FailurePoint52;
			}
		FlatButtonSelectedBits = MakeBitmap(oFlatButtonSelected,24,24,3);
		if (FlatButtonSelectedBits == NIL)
			{
			 FailurePoint54:
				DisposeBitmap(SharpButtonSelectedBits);
				goto FailurePoint53;
			}
		NaturalButtonSelectedBits = MakeBitmap(oNaturalButtonSelected,24,24,3);
		if (NaturalButtonSelectedBits == NIL)
			{
			 FailurePoint55:
				DisposeBitmap(FlatButtonSelectedBits);
				goto FailurePoint54;
			}
		NoteVsRestButtonSelectedBits = MakeBitmap(oNoteVsRestButtonSelected,24,24,3);
		if (NoteVsRestButtonSelectedBits == NIL)
			{
			 FailurePoint56:
				DisposeBitmap(NaturalButtonSelectedBits);
				goto FailurePoint55;
			}
		RestVsNoteButtonSelectedBits = MakeBitmap(oRestVsNoteButtonSelected,24,24,3);
		if (RestVsNoteButtonSelectedBits == NIL)
			{
			 FailurePoint57:
				DisposeBitmap(NoteVsRestButtonSelectedBits);
				goto FailurePoint56;
			}
		NoDotButtonSelectedBits = MakeBitmap(oNoDotButtonSelected,24,24,3);
		if (NoDotButtonSelectedBits == NIL)
			{
			 FailurePoint58:
				DisposeBitmap(RestVsNoteButtonSelectedBits);
				goto FailurePoint57;
			}
		YesDotButtonSelectedBits = MakeBitmap(oYesDotButtonSelected,24,24,3);
		if (YesDotButtonSelectedBits == NIL)
			{
			 FailurePoint59:
				DisposeBitmap(NoDotButtonSelectedBits);
				goto FailurePoint58;
			}
		Div1ButtonSelectedBits = MakeBitmap(oDiv1ButtonSelected,24,24,3);
		if (Div1ButtonSelectedBits == NIL)
			{
			 FailurePoint60:
				DisposeBitmap(YesDotButtonSelectedBits);
				goto FailurePoint59;
			}
		Div3ButtonSelectedBits = MakeBitmap(oDiv3ButtonSelected,24,24,3);
		if (Div3ButtonSelectedBits == NIL)
			{
			 FailurePoint61:
				DisposeBitmap(Div1ButtonSelectedBits);
				goto FailurePoint60;
			}
		Div5ButtonSelectedBits = MakeBitmap(oDiv5ButtonSelected,24,24,3);
		if (Div5ButtonSelectedBits == NIL)
			{
			 FailurePoint62:
				DisposeBitmap(Div3ButtonSelectedBits);
				goto FailurePoint61;
			}
		Div7ButtonSelectedBits = MakeBitmap(oDiv7ButtonSelected,24,24,3);
		if (Div7ButtonSelectedBits == NIL)
			{
			 FailurePoint63:
				DisposeBitmap(Div5ButtonSelectedBits);
				goto FailurePoint62;
			}

		ArrowButtonSelectedMouseDownBits = MakeBitmap(oArrowButtonSelectedMouseDown,24,24,3);
		if (ArrowButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint64:
				DisposeBitmap(Div7ButtonSelectedBits);
				goto FailurePoint63;
			}
		SixtyFourthButtonSelectedMouseDownBits = MakeBitmap(oSixtyFourthButtonSelectedMouseDown,24,24,3);
		if (SixtyFourthButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint65:
				DisposeBitmap(ArrowButtonSelectedMouseDownBits);
				goto FailurePoint64;
			}
		ThirtySecondButtonSelectedMouseDownBits = MakeBitmap(oThirtySecondButtonSelectedMouseDown,24,24,3);
		if (ThirtySecondButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint66:
				DisposeBitmap(SixtyFourthButtonSelectedMouseDownBits);
				goto FailurePoint65;
			}
		SixteenthButtonSelectedMouseDownBits = MakeBitmap(oSixteenthButtonSelectedMouseDown,24,24,3);
		if (SixteenthButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint67:
				DisposeBitmap(ThirtySecondButtonSelectedMouseDownBits);
				goto FailurePoint66;
			}
		EighthButtonSelectedMouseDownBits = MakeBitmap(oEighthButtonSelectedMouseDown,24,24,3);
		if (EighthButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint68:
				DisposeBitmap(SixteenthButtonSelectedMouseDownBits);
				goto FailurePoint67;
			}
		QuarterButtonSelectedMouseDownBits = MakeBitmap(oQuarterButtonSelectedMouseDown,24,24,3);
		if (QuarterButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint69:
				DisposeBitmap(EighthButtonSelectedMouseDownBits);
				goto FailurePoint68;
			}
		HalfButtonSelectedMouseDownBits = MakeBitmap(oHalfButtonSelectedMouseDown,24,24,3);
		if (HalfButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint70:
				DisposeBitmap(QuarterButtonSelectedMouseDownBits);
				goto FailurePoint69;
			}
		WholeButtonSelectedMouseDownBits = MakeBitmap(oWholeButtonSelectedMouseDown,24,24,3);
		if (WholeButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint71:
				DisposeBitmap(HalfButtonSelectedMouseDownBits);
				goto FailurePoint70;
			}
		DoubleButtonSelectedMouseDownBits = MakeBitmap(oDoubleButtonSelectedMouseDown,24,24,3);
		if (DoubleButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint72:
				DisposeBitmap(WholeButtonSelectedMouseDownBits);
				goto FailurePoint71;
			}
		QuadButtonSelectedMouseDownBits = MakeBitmap(oQuadButtonSelectedMouseDown,24,24,3);
		if (QuadButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint73:
				DisposeBitmap(DoubleButtonSelectedMouseDownBits);
				goto FailurePoint72;
			}
		SharpButtonSelectedMouseDownBits = MakeBitmap(oSharpButtonSelectedMouseDown,24,24,3);
		if (SharpButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint74:
				DisposeBitmap(QuadButtonSelectedMouseDownBits);
				goto FailurePoint73;
			}
		FlatButtonSelectedMouseDownBits = MakeBitmap(oFlatButtonSelectedMouseDown,24,24,3);
		if (FlatButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint75:
				DisposeBitmap(SharpButtonSelectedMouseDownBits);
				goto FailurePoint74;
			}
		NaturalButtonSelectedMouseDownBits = MakeBitmap(oNaturalButtonSelectedMouseDown,24,24,3);
		if (NaturalButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint76:
				DisposeBitmap(FlatButtonSelectedMouseDownBits);
				goto FailurePoint75;
			}
		NoteVsRestButtonSelectedMouseDownBits = MakeBitmap(oNoteVsRestButtonSelectedMouseDown,24,24,3);
		if (NoteVsRestButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint77:
				DisposeBitmap(NaturalButtonSelectedMouseDownBits);
				goto FailurePoint76;
			}
		RestVsNoteButtonSelectedMouseDownBits = MakeBitmap(oRestVsNoteButtonSelectedMouseDown,24,24,3);
		if (RestVsNoteButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint78:
				DisposeBitmap(NoteVsRestButtonSelectedMouseDownBits);
				goto FailurePoint77;
			}
		NoDotButtonSelectedMouseDownBits = MakeBitmap(oNoDotButtonSelectedMouseDown,24,24,3);
		if (NoDotButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint79:
				DisposeBitmap(RestVsNoteButtonSelectedMouseDownBits);
				goto FailurePoint78;
			}
		YesDotButtonSelectedMouseDownBits = MakeBitmap(oYesDotButtonSelectedMouseDown,24,24,3);
		if (YesDotButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint80:
				DisposeBitmap(NoDotButtonSelectedMouseDownBits);
				goto FailurePoint79;
			}
		Div1ButtonSelectedMouseDownBits = MakeBitmap(oDiv1ButtonSelectedMouseDown,24,24,3);
		if (Div1ButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint81:
				DisposeBitmap(YesDotButtonSelectedMouseDownBits);
				goto FailurePoint80;
			}
		Div3ButtonSelectedMouseDownBits = MakeBitmap(oDiv3ButtonSelectedMouseDown,24,24,3);
		if (Div3ButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint82:
				DisposeBitmap(Div1ButtonSelectedMouseDownBits);
				goto FailurePoint81;
			}
		Div5ButtonSelectedMouseDownBits = MakeBitmap(oDiv5ButtonSelectedMouseDown,24,24,3);
		if (Div5ButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint83:
				DisposeBitmap(Div3ButtonSelectedMouseDownBits);
				goto FailurePoint82;
			}
		Div7ButtonSelectedMouseDownBits = MakeBitmap(oDiv7ButtonSelectedMouseDown,24,24,3);
		if (Div7ButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint84:
				DisposeBitmap(Div5ButtonSelectedMouseDownBits);
				goto FailurePoint83;
			}
		CommandButtonBits = MakeBitmap(oCommandButton,24,24,3);
		if (CommandButtonBits == NIL)
			{
			 FailurePoint85:
				DisposeBitmap(Div7ButtonSelectedMouseDownBits);
				goto FailurePoint84;
			}
		CommandButtonMouseDownBits = MakeBitmap(oCommandButtonMouseDown,24,24,3);
		if (CommandButtonMouseDownBits == NIL)
			{
			 FailurePoint86:
				DisposeBitmap(CommandButtonBits);
				goto FailurePoint85;
			}
		CommandButtonSelectedBits = MakeBitmap(oCommandButtonSelected,24,24,3);
		if (CommandButtonSelectedBits == NIL)
			{
			 FailurePoint87:
				DisposeBitmap(CommandButtonMouseDownBits);
				goto FailurePoint86;
			}
		CommandButtonSelectedMouseDownBits = MakeBitmap(oCommandButtonSelectedMouseDown,24,24,3);
		if (CommandButtonSelectedMouseDownBits == NIL)
			{
			 FailurePoint88:
				DisposeBitmap(CommandButtonSelectedBits);
				goto FailurePoint87;
			}
		return True;
	}


void								CleanupNoteButtonImages(void)
	{
		ERROR(!Initialized,PRERR(ForceAbort,"CleanupNoteButtonImages:  not initialized"));
		EXECUTE(Initialized = False;)
		DisposeBitmap(ArrowButtonBits);
		DisposeBitmap(SixtyFourthButtonBits);
		DisposeBitmap(ThirtySecondButtonBits);
		DisposeBitmap(SixteenthButtonBits);
		DisposeBitmap(EighthButtonBits);
		DisposeBitmap(QuarterButtonBits);
		DisposeBitmap(HalfButtonBits);
		DisposeBitmap(WholeButtonBits);
		DisposeBitmap(DoubleButtonBits);
		DisposeBitmap(QuadButtonBits);
		DisposeBitmap(SharpButtonBits);
		DisposeBitmap(FlatButtonBits);
		DisposeBitmap(NaturalButtonBits);
		DisposeBitmap(NoteVsRestButtonBits);
		DisposeBitmap(RestVsNoteButtonBits);
		DisposeBitmap(NoDotButtonBits);
		DisposeBitmap(YesDotButtonBits);
		DisposeBitmap(Div1ButtonBits);
		DisposeBitmap(Div3ButtonBits);
		DisposeBitmap(Div5ButtonBits);
		DisposeBitmap(Div7ButtonBits);
		DisposeBitmap(CommandButtonBits);

		DisposeBitmap(ArrowButtonMouseDownBits);
		DisposeBitmap(SixtyFourthButtonMouseDownBits);
		DisposeBitmap(ThirtySecondButtonMouseDownBits);
		DisposeBitmap(SixteenthButtonMouseDownBits);
		DisposeBitmap(EighthButtonMouseDownBits);
		DisposeBitmap(QuarterButtonMouseDownBits);
		DisposeBitmap(HalfButtonMouseDownBits);
		DisposeBitmap(WholeButtonMouseDownBits);
		DisposeBitmap(DoubleButtonMouseDownBits);
		DisposeBitmap(QuadButtonMouseDownBits);
		DisposeBitmap(SharpButtonMouseDownBits);
		DisposeBitmap(FlatButtonMouseDownBits);
		DisposeBitmap(NaturalButtonMouseDownBits);
		DisposeBitmap(NoteVsRestButtonMouseDownBits);
		DisposeBitmap(RestVsNoteButtonMouseDownBits);
		DisposeBitmap(NoDotButtonMouseDownBits);
		DisposeBitmap(YesDotButtonMouseDownBits);
		DisposeBitmap(Div1ButtonMouseDownBits);
		DisposeBitmap(Div3ButtonMouseDownBits);
		DisposeBitmap(Div5ButtonMouseDownBits);
		DisposeBitmap(Div7ButtonMouseDownBits);
		DisposeBitmap(CommandButtonMouseDownBits);

		DisposeBitmap(ArrowButtonSelectedBits);
		DisposeBitmap(SixtyFourthButtonSelectedBits);
		DisposeBitmap(ThirtySecondButtonSelectedBits);
		DisposeBitmap(SixteenthButtonSelectedBits);
		DisposeBitmap(EighthButtonSelectedBits);
		DisposeBitmap(QuarterButtonSelectedBits);
		DisposeBitmap(HalfButtonSelectedBits);
		DisposeBitmap(WholeButtonSelectedBits);
		DisposeBitmap(DoubleButtonSelectedBits);
		DisposeBitmap(QuadButtonSelectedBits);
		DisposeBitmap(SharpButtonSelectedBits);
		DisposeBitmap(FlatButtonSelectedBits);
		DisposeBitmap(NaturalButtonSelectedBits);
		DisposeBitmap(NoteVsRestButtonSelectedBits);
		DisposeBitmap(RestVsNoteButtonSelectedBits);
		DisposeBitmap(NoDotButtonSelectedBits);
		DisposeBitmap(YesDotButtonSelectedBits);
		DisposeBitmap(Div1ButtonSelectedBits);
		DisposeBitmap(Div3ButtonSelectedBits);
		DisposeBitmap(Div5ButtonSelectedBits);
		DisposeBitmap(Div7ButtonSelectedBits);
		DisposeBitmap(CommandButtonSelectedBits);

		DisposeBitmap(ArrowButtonSelectedMouseDownBits);
		DisposeBitmap(SixtyFourthButtonSelectedMouseDownBits);
		DisposeBitmap(ThirtySecondButtonSelectedMouseDownBits);
		DisposeBitmap(SixteenthButtonSelectedMouseDownBits);
		DisposeBitmap(EighthButtonSelectedMouseDownBits);
		DisposeBitmap(QuarterButtonSelectedMouseDownBits);
		DisposeBitmap(HalfButtonSelectedMouseDownBits);
		DisposeBitmap(WholeButtonSelectedMouseDownBits);
		DisposeBitmap(DoubleButtonSelectedMouseDownBits);
		DisposeBitmap(QuadButtonSelectedMouseDownBits);
		DisposeBitmap(SharpButtonSelectedMouseDownBits);
		DisposeBitmap(FlatButtonSelectedMouseDownBits);
		DisposeBitmap(NaturalButtonSelectedMouseDownBits);
		DisposeBitmap(NoteVsRestButtonSelectedMouseDownBits);
		DisposeBitmap(RestVsNoteButtonSelectedMouseDownBits);
		DisposeBitmap(NoDotButtonSelectedMouseDownBits);
		DisposeBitmap(YesDotButtonSelectedMouseDownBits);
		DisposeBitmap(Div1ButtonSelectedMouseDownBits);
		DisposeBitmap(Div3ButtonSelectedMouseDownBits);
		DisposeBitmap(Div5ButtonSelectedMouseDownBits);
		DisposeBitmap(Div7ButtonSelectedMouseDownBits);
		DisposeBitmap(CommandButtonSelectedMouseDownBits);
	}
