/* NoteImages.c */
/*****************************************************************************/
/*                                                                           */
/*    Synthesizer:  Digital Music Synthesis on General Purpose Computers     */
/*    Copyright (C) 1994  Thomas R. Lawrence                                 */
/*                                                                           */
/*    This program is free software; you can redistribute it and/or modify   */
/*    it under the terms of the GNU General Public License as published by   */
/*    the Free Software Foundation; either version 2 of the License, or      */
/*    (at your option) any later version.                                    */
/*                                                                           */
/*    This program is distributed in the hope that it will be useful,        */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/*    GNU General Public License for more details.                           */
/*                                                                           */
/*    You should have received a copy of the GNU General Public License      */
/*    along with this program; if not, write to the Free Software            */
/*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              */
/*                                                                           */
/*    Thomas R. Lawrence can be reached at tomlaw@world.std.com.             */
/*                                                                           */
/*****************************************************************************/

#include "MiscInfo.h"
#include "Audit.h"
#include "Debug.h"
#include "Definitions.h"

#define Compiling_NoteImages
#include "NoteImages.h"
#include "Screen.h"


EXECUTE(static MyBoolean		Initialized = False;)

Bitmap*											SixtyFourthNoteImage;
Bitmap*											SixtyFourthNoteMask;
Bitmap*											ThirtySecondNoteImage;
Bitmap*											ThirtySecondNoteMask;
Bitmap*											SixteenthNoteImage;
Bitmap*											SixteenthNoteMask;
Bitmap*											EighthNoteImage;
Bitmap*											EighthNoteMask;
Bitmap*											QuarterNoteImage;
Bitmap*											QuarterNoteMask;
Bitmap*											HalfNoteImage;
Bitmap*											HalfNoteMask;
Bitmap*											WholeNoteImage;
Bitmap*											WholeNoteMask;
Bitmap*											DoubleNoteImage;
Bitmap*											DoubleNoteMask;
Bitmap*											QuadNoteImage;
Bitmap*											QuadNoteMask;
Bitmap*											DotImage;
Bitmap*											DotMask;
Bitmap*											SharpImage;
Bitmap*											SharpMask;
Bitmap*											FlatImage;
Bitmap*											FlatMask;
Bitmap*											NaturalImage;
Bitmap*											NaturalMask;
Bitmap*											SortaSharpImage;
Bitmap*											SortaSharpMask;
Bitmap*											SortaFlatImage;
Bitmap*											SortaFlatMask;
Bitmap*											Div3Image;
Bitmap*											Div3Mask;
Bitmap*											Div5Image;
Bitmap*											Div5Mask;
Bitmap*											Div7Image;
Bitmap*											Div7Mask;
Bitmap*											SixtyFourthRestImage;
Bitmap*											SixtyFourthRestMask;
Bitmap*											ThirtySecondRestImage;
Bitmap*											ThirtySecondRestMask;
Bitmap*											SixteenthRestImage;
Bitmap*											SixteenthRestMask;
Bitmap*											EighthRestImage;
Bitmap*											EighthRestMask;
Bitmap*											QuarterRestImage;
Bitmap*											QuarterRestMask;
Bitmap*											HalfRestImage;
Bitmap*											HalfRestMask;
Bitmap*											WholeRestImage;
Bitmap*											WholeRestMask;
Bitmap*											DoubleRestImage;
Bitmap*											DoubleRestMask;
Bitmap*											QuadRestImage;
Bitmap*											QuadRestMask;
Bitmap*											GreyMask;


static char									oSixtyFourthNoteImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x3C,0x00,0x00,0x00,0x27,0x00,
		0x00,0x00,0x31,0xC0,0x00,0x00,0x3C,0x40,0x00,0x00,0x27,0x00,0x00,0x00,0x31,0xC0,
		0x00,0x00,0x3C,0x40,0x00,0x00,0x27,0x00,0x00,0x00,0x31,0xC0,0x00,0x00,0x3C,0x40,
		0x00,0x00,0x27,0x00,0x00,0x00,0x21,0xC0,0x00,0x00,0x20,0x40,0x00,0x00,0x20,0x00,
		0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x03,0xE0,0x00,0x00,0x0F,0xE0,0x00,0x00,0x1F,0xE0,0x00,0x00,0x3F,0xE0,0x00,
		0x00,0x3F,0xC0,0x00,0x00,0x3F,0x80,0x00,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oSixtyFourthNoteMask[] =
	{
		0x00,0x00,0x78,0x00,0x00,0x00,0x7E,0x00,0x00,0x00,0x7F,0x80,0x00,0x00,0x7F,0xE0,
		0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xE0,
		0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xE0,
		0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xE0,0x00,0x00,0x73,0xE0,0x00,0x00,0x70,0xE0,
		0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x07,0xF0,0x00,
		0x00,0x1F,0xF0,0x00,0x00,0x3F,0xF0,0x00,0x00,0x7F,0xF0,0x00,0x00,0x7F,0xF0,0x00,
		0x00,0x7F,0xF0,0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xC0,0x00,0x00,0x3F,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oThirtySecondNoteImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x3C,0x00,0x00,0x00,0x27,0x00,
		0x00,0x00,0x31,0xC0,0x00,0x00,0x3C,0x40,0x00,0x00,0x27,0x00,0x00,0x00,0x31,0xC0,
		0x00,0x00,0x3C,0x40,0x00,0x00,0x27,0x00,0x00,0x00,0x21,0xC0,0x00,0x00,0x20,0x40,
		0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x03,0xE0,0x00,0x00,0x0F,0xE0,0x00,0x00,0x1F,0xE0,0x00,0x00,0x3F,0xE0,0x00,
		0x00,0x3F,0xC0,0x00,0x00,0x3F,0x80,0x00,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oThirtySecondNoteMask[] =
	{
		0x00,0x00,0x78,0x00,0x00,0x00,0x7E,0x00,0x00,0x00,0x7F,0x80,0x00,0x00,0x7F,0xE0,
		0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xE0,
		0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xE0,0x00,0x00,0x73,0xE0,
		0x00,0x00,0x70,0xE0,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,
		0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x07,0xF0,0x00,
		0x00,0x1F,0xF0,0x00,0x00,0x3F,0xF0,0x00,0x00,0x7F,0xF0,0x00,0x00,0x7F,0xF0,0x00,
		0x00,0x7F,0xF0,0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xC0,0x00,0x00,0x3F,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oSixteenthNoteImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x3C,0x00,0x00,0x00,0x27,0x00,
		0x00,0x00,0x31,0xC0,0x00,0x00,0x3C,0x40,0x00,0x00,0x27,0x00,0x00,0x00,0x21,0xC0,
		0x00,0x00,0x20,0x40,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x03,0xE0,0x00,0x00,0x0F,0xE0,0x00,0x00,0x1F,0xE0,0x00,0x00,0x3F,0xE0,0x00,
		0x00,0x3F,0xC0,0x00,0x00,0x3F,0x80,0x00,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oSixteenthNoteMask[] =
	{
		0x00,0x00,0x78,0x00,0x00,0x00,0x7E,0x00,0x00,0x00,0x7F,0x80,0x00,0x00,0x7F,0xE0,
		0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xE0,
		0x00,0x00,0x73,0xE0,0x00,0x00,0x70,0xE0,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,
		0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,
		0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x07,0xF0,0x00,
		0x00,0x1F,0xF0,0x00,0x00,0x3F,0xF0,0x00,0x00,0x7F,0xF0,0x00,0x00,0x7F,0xF0,0x00,
		0x00,0x7F,0xF0,0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xC0,0x00,0x00,0x3F,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oEighthNoteImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x3C,0x00,0x00,0x00,0x27,0x00,
		0x00,0x00,0x21,0xC0,0x00,0x00,0x20,0x40,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x03,0xE0,0x00,0x00,0x0F,0xE0,0x00,0x00,0x1F,0xE0,0x00,0x00,0x3F,0xE0,0x00,
		0x00,0x3F,0xC0,0x00,0x00,0x3F,0x80,0x00,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oEighthNoteMask[] =
	{
		0x00,0x00,0x78,0x00,0x00,0x00,0x7E,0x00,0x00,0x00,0x7F,0x80,0x00,0x00,0x7F,0xE0,
		0x00,0x00,0x7F,0xE0,0x00,0x00,0x73,0xE0,0x00,0x00,0x70,0xE0,0x00,0x00,0x70,0x00,
		0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,
		0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,
		0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x07,0xF0,0x00,
		0x00,0x1F,0xF0,0x00,0x00,0x3F,0xF0,0x00,0x00,0x7F,0xF0,0x00,0x00,0x7F,0xF0,0x00,
		0x00,0x7F,0xF0,0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xC0,0x00,0x00,0x3F,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oQuarterNoteImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x03,0xE0,0x00,0x00,0x0F,0xE0,0x00,0x00,0x1F,0xE0,0x00,0x00,0x3F,0xE0,0x00,
		0x00,0x3F,0xC0,0x00,0x00,0x3F,0x80,0x00,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oQuarterNoteMask[] =
	{
		0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,
		0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,
		0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,
		0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,
		0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x07,0xF0,0x00,
		0x00,0x1F,0xF0,0x00,0x00,0x3F,0xF0,0x00,0x00,0x7F,0xF0,0x00,0x00,0x7F,0xF0,0x00,
		0x00,0x7F,0xF0,0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xC0,0x00,0x00,0x3F,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oHalfNoteImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x20,0x00,
		0x00,0x03,0xE0,0x00,0x00,0x0C,0x20,0x00,0x00,0x10,0x20,0x00,0x00,0x20,0x20,0x00,
		0x00,0x20,0x40,0x00,0x00,0x21,0x80,0x00,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oHalfNoteMask[] =
	{
		0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,
		0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,
		0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,
		0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,
		0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x70,0x00,0x00,0x07,0xF0,0x00,
		0x00,0x1F,0xF0,0x00,0x00,0x3F,0xF0,0x00,0x00,0x7E,0x70,0x00,0x00,0x78,0xF0,0x00,
		0x00,0x73,0xF0,0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xC0,0x00,0x00,0x3F,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oWholeNoteImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x03,0xC0,0x00,0x00,0x0C,0x20,0x00,0x00,0x10,0x20,0x00,0x00,0x20,0x20,0x00,
		0x00,0x20,0x40,0x00,0x00,0x21,0x80,0x00,0x00,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oWholeNoteMask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xE0,0x00,
		0x00,0x1F,0xF0,0x00,0x00,0x3F,0xF0,0x00,0x00,0x7E,0x70,0x00,0x00,0x78,0xF0,0x00,
		0x00,0x73,0xF0,0x00,0x00,0x7F,0xE0,0x00,0x00,0x7F,0xC0,0x00,0x00,0x3F,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oDoubleNoteImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x10,0x00,
		0x00,0x43,0xD0,0x00,0x00,0x4C,0x30,0x00,0x00,0x50,0x30,0x00,0x00,0x60,0x30,0x00,
		0x00,0x60,0x50,0x00,0x00,0x61,0x90,0x00,0x00,0x5E,0x10,0x00,0x00,0x40,0x10,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oDoubleNoteMask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xE0,0x38,0x00,0x00,0xE3,0xF8,0x00,
		0x00,0xEF,0xF8,0x00,0x00,0xFF,0xF8,0x00,0x00,0xFC,0x78,0x00,0x00,0xF8,0xF8,0x00,
		0x00,0xF1,0xF8,0x00,0x00,0xFF,0xF8,0x00,0x00,0xFF,0xB8,0x00,0x00,0xFE,0x38,0x00,
		0x00,0xE0,0x38,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oQuadNoteImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x10,0x00,
		0x00,0x7F,0xF0,0x00,0x00,0x7F,0xF0,0x00,0x00,0x40,0x10,0x00,0x00,0x40,0x10,0x00,
		0x00,0x40,0x10,0x00,0x00,0x7F,0xF0,0x00,0x00,0x7F,0xF0,0x00,0x00,0x40,0x10,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oQuadNoteMask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xE0,0x38,0x00,0x00,0xFF,0xF8,0x00,
		0x00,0xFF,0xF8,0x00,0x00,0xFF,0xF8,0x00,0x00,0xFF,0xF8,0x00,0x00,0xE0,0x38,0x00,
		0x00,0xFF,0xF8,0x00,0x00,0xFF,0xF8,0x00,0x00,0xFF,0xF8,0x00,0x00,0xFF,0xF8,0x00,
		0x00,0xE0,0x38,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oDotImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x80,0x00,0x00,0x03,0x80,
		0x00,0x00,0x03,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oDotMask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xC0,0x00,0x00,0x07,0xC0,0x00,0x00,0x07,0xC0,
		0x00,0x00,0x07,0xC0,0x00,0x00,0x07,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oSharpImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x02,0x00,0x00,0x00,
		0x12,0x00,0x00,0x00,0x17,0x00,0x00,0x00,0x3A,0x00,0x00,0x00,0x12,0x00,0x00,0x00,
		0x12,0x00,0x00,0x00,0x12,0x00,0x00,0x00,0x17,0x00,0x00,0x00,0x3A,0x00,0x00,0x00,
		0x12,0x00,0x00,0x00,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oSharpMask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x07,0x00,0x00,0x00,0x07,0x00,0x00,0x00,0x3F,0x00,0x00,0x00,
		0x3F,0x80,0x00,0x00,0x7F,0x80,0x00,0x00,0x7F,0x80,0x00,0x00,0x7F,0x00,0x00,0x00,
		0x3F,0x00,0x00,0x00,0x3F,0x80,0x00,0x00,0x7F,0x80,0x00,0x00,0x7F,0x80,0x00,0x00,
		0x7F,0x00,0x00,0x00,0x3F,0x00,0x00,0x00,0x38,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oFlatImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x00,0x00,0x00,
		0x10,0x00,0x00,0x00,0x10,0x00,0x00,0x00,0x10,0x00,0x00,0x00,0x10,0x00,0x00,0x00,
		0x10,0x00,0x00,0x00,0x10,0x00,0x00,0x00,0x17,0x00,0x00,0x00,0x19,0x00,0x00,0x00,
		0x11,0x00,0x00,0x00,0x12,0x00,0x00,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oFlatMask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x00,0x00,0x00,0x38,0x00,0x00,0x00,
		0x38,0x00,0x00,0x00,0x38,0x00,0x00,0x00,0x38,0x00,0x00,0x00,0x38,0x00,0x00,0x00,
		0x38,0x00,0x00,0x00,0x3F,0x80,0x00,0x00,0x3F,0x80,0x00,0x00,0x3F,0x80,0x00,0x00,
		0x3F,0x80,0x00,0x00,0x3F,0x80,0x00,0x00,0x3F,0x00,0x00,0x00,0x3E,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oNaturalImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x10,0x00,0x00,0x00,0x16,0x00,0x00,0x00,0x1A,0x00,0x00,0x00,0x12,0x00,0x00,0x00,
		0x12,0x00,0x00,0x00,0x12,0x00,0x00,0x00,0x16,0x00,0x00,0x00,0x1A,0x00,0x00,0x00,
		0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oNaturalMask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x00,0x00,0x00,
		0x3F,0x00,0x00,0x00,0x3F,0x00,0x00,0x00,0x3F,0x00,0x00,0x00,0x3F,0x00,0x00,0x00,
		0x3F,0x00,0x00,0x00,0x3F,0x00,0x00,0x00,0x3F,0x00,0x00,0x00,0x3F,0x00,0x00,0x00,
		0x3F,0x00,0x00,0x00,0x07,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oSortaSharpImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x02,0x00,0x00,0x00,
		0x12,0x00,0x00,0x00,0x13,0x00,0x00,0x00,0x30,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x00,0x00,0x32,0x00,0x00,0x00,
		0x12,0x00,0x00,0x00,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oSortaSharpMask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x07,0x00,0x00,0x00,0x07,0x00,0x00,0x00,0x3F,0x00,0x00,0x00,
		0x3F,0x80,0x00,0x00,0x7F,0x80,0x00,0x00,0x7F,0x80,0x00,0x00,0x7F,0x80,0x00,0x00,
		0x7F,0x80,0x00,0x00,0x7F,0x80,0x00,0x00,0x7F,0x80,0x00,0x00,0x7F,0x80,0x00,0x00,
		0x7F,0x00,0x00,0x00,0x3F,0x00,0x00,0x00,0x38,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oSortaFlatImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x15,0x00,0x00,0x00,0x08,0x00,0x00,0x00,
		0x11,0x00,0x00,0x00,0x02,0x00,0x00,0x00,0x14,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oSortaFlatMask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x38,0x00,0x00,0x00,
		0x38,0x00,0x00,0x00,0x38,0x00,0x00,0x00,0x38,0x00,0x00,0x00,0x38,0x00,0x00,0x00,
		0x38,0x00,0x00,0x00,0x3F,0x80,0x00,0x00,0x3F,0x80,0x00,0x00,0x3F,0x80,0x00,0x00,
		0x3F,0x80,0x00,0x00,0x3F,0x80,0x00,0x00,0x3F,0x00,0x00,0x00,0x3E,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oDiv3Image[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x80,0x00,0x00,
		0x00,0xC0,0x00,0x00,0x00,0xC0,0x00,0x00,0x03,0x80,0x00,0x00,0x00,0xC0,0x00,0x00,
		0x00,0xC0,0x00,0x00,0x03,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oDiv3Mask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xC0,0x00,0x00,0x07,0xE0,0x00,0x00,
		0x07,0xE0,0x00,0x00,0x07,0xE0,0x00,0x00,0x07,0xE0,0x00,0x00,0x07,0xE0,0x00,0x00,
		0x07,0xE0,0x00,0x00,0x07,0xE0,0x00,0x00,0x07,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oDiv5Image[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xC0,0x00,0x00,
		0x03,0x00,0x00,0x00,0x03,0x00,0x00,0x00,0x03,0x80,0x00,0x00,0x00,0xC0,0x00,0x00,
		0x00,0xC0,0x00,0x00,0x03,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oDiv5Mask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xE0,0x00,0x00,0x07,0xE0,0x00,0x00,
		0x07,0xE0,0x00,0x00,0x07,0xC0,0x00,0x00,0x07,0xE0,0x00,0x00,0x07,0xE0,0x00,0x00,
		0x07,0xE0,0x00,0x00,0x07,0xE0,0x00,0x00,0x07,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oDiv7Image[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xC0,0x00,0x00,
		0x00,0xC0,0x00,0x00,0x00,0xC0,0x00,0x00,0x01,0x80,0x00,0x00,0x01,0x80,0x00,0x00,
		0x03,0x00,0x00,0x00,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oDiv7Mask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xE0,0x00,0x00,0x07,0xE0,0x00,0x00,
		0x07,0xE0,0x00,0x00,0x03,0xE0,0x00,0x00,0x03,0xE0,0x00,0x00,0x07,0xC0,0x00,0x00,
		0x07,0xC0,0x00,0x00,0x07,0x80,0x00,0x00,0x07,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oSixtyFourthRestImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC6,0x00,
		0x00,0x01,0xDA,0x00,0x00,0x01,0xE4,0x00,0x00,0x00,0x04,0x00,0x00,0x03,0x18,0x00,
		0x00,0x07,0x68,0x00,0x00,0x07,0x90,0x00,0x00,0x00,0x10,0x00,0x00,0x0C,0x60,0x00,
		0x00,0x1D,0xA0,0x00,0x00,0x1E,0x40,0x00,0x00,0x00,0x40,0x00,0x00,0x31,0x80,0x00,
		0x00,0x76,0x80,0x00,0x00,0x79,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x02,0x00,0x00,
		0x00,0x02,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x08,0x00,0x00,
		0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oSixtyFourthRestMask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xEF,0x00,0x00,0x03,0xFF,0x00,
		0x00,0x03,0xFF,0x00,0x00,0x03,0xFF,0x00,0x00,0x07,0xFE,0x00,0x00,0x0F,0xFE,0x00,
		0x00,0x0F,0xFC,0x00,0x00,0x0F,0xFC,0x00,0x00,0x1F,0xF8,0x00,0x00,0x3F,0xF8,0x00,
		0x00,0x3F,0xF0,0x00,0x00,0x3F,0xF0,0x00,0x00,0x7F,0xE0,0x00,0x00,0xFF,0xE0,0x00,
		0x00,0xFF,0xC0,0x00,0x00,0xFF,0xC0,0x00,0x00,0xFF,0x80,0x00,0x00,0x07,0x80,0x00,
		0x00,0x0F,0x00,0x00,0x00,0x0F,0x00,0x00,0x00,0x1E,0x00,0x00,0x00,0x1E,0x00,0x00,
		0x00,0x1C,0x00,0x00,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oThirtySecondRestImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x18,0x00,
		0x00,0x07,0x68,0x00,0x00,0x07,0x90,0x00,0x00,0x00,0x10,0x00,0x00,0x0C,0x60,0x00,
		0x00,0x1D,0xA0,0x00,0x00,0x1E,0x40,0x00,0x00,0x00,0x40,0x00,0x00,0x31,0x80,0x00,
		0x00,0x76,0x80,0x00,0x00,0x79,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x02,0x00,0x00,
		0x00,0x02,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x08,0x00,0x00,
		0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oThirtySecondRestMask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xBC,0x00,0x00,0x0F,0xFC,0x00,
		0x00,0x0F,0xFC,0x00,0x00,0x0F,0xFC,0x00,0x00,0x1F,0xF8,0x00,0x00,0x3F,0xF8,0x00,
		0x00,0x3F,0xF0,0x00,0x00,0x3F,0xF0,0x00,0x00,0x7F,0xE0,0x00,0x00,0xFF,0xE0,0x00,
		0x00,0xFF,0xC0,0x00,0x00,0xFF,0xC0,0x00,0x00,0xFF,0x80,0x00,0x00,0x07,0x80,0x00,
		0x00,0x0F,0x00,0x00,0x00,0x0F,0x00,0x00,0x00,0x1E,0x00,0x00,0x00,0x1E,0x00,0x00,
		0x00,0x1C,0x00,0x00,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oSixteenthRestImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x18,0x00,
		0x00,0x07,0x68,0x00,0x00,0x07,0x90,0x00,0x00,0x00,0x10,0x00,0x00,0x0C,0x60,0x00,
		0x00,0x1D,0xA0,0x00,0x00,0x1E,0x40,0x00,0x00,0x00,0x40,0x00,0x00,0x00,0x80,0x00,
		0x00,0x00,0x80,0x00,0x00,0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x02,0x00,0x00,
		0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oSixteenthRestMask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xBC,0x00,0x00,0x0F,0xFC,0x00,
		0x00,0x0F,0xFC,0x00,0x00,0x0F,0xFC,0x00,0x00,0x1F,0xF8,0x00,0x00,0x3F,0xF8,0x00,
		0x00,0x3F,0xF0,0x00,0x00,0x3F,0xF0,0x00,0x00,0x3F,0xE0,0x00,0x00,0x01,0xE0,0x00,
		0x00,0x03,0xC0,0x00,0x00,0x03,0xC0,0x00,0x00,0x07,0x80,0x00,0x00,0x07,0x80,0x00,
		0x00,0x07,0x00,0x00,0x00,0x07,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oEighthRestImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x18,0x00,
		0x00,0x07,0x68,0x00,0x00,0x07,0x90,0x00,0x00,0x00,0x10,0x00,0x00,0x00,0x20,0x00,
		0x00,0x00,0x20,0x00,0x00,0x00,0x40,0x00,0x00,0x00,0x40,0x00,0x00,0x00,0x80,0x00,
		0x00,0x00,0x80,0x00,0x00,0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oEighthRestMask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xBC,0x00,0x00,0x0F,0xFC,0x00,
		0x00,0x0F,0xFC,0x00,0x00,0x0F,0xFC,0x00,0x00,0x0F,0xF8,0x00,0x00,0x00,0x78,0x00,
		0x00,0x00,0xF0,0x00,0x00,0x00,0xF0,0x00,0x00,0x01,0xE0,0x00,0x00,0x01,0xE0,0x00,
		0x00,0x03,0xC0,0x00,0x00,0x03,0xC0,0x00,0x00,0x03,0x80,0x00,0x00,0x03,0x80,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oQuarterRestImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x08,0x00,0x00,0x00,0x06,0x00,0x00,0x00,0x03,0x00,0x00,
		0x00,0x03,0x00,0x00,0x00,0x06,0x00,0x00,0x00,0x06,0x00,0x00,0x00,0x03,0x00,0x00,
		0x00,0x06,0x80,0x00,0x00,0x0C,0x00,0x00,0x00,0x0C,0x00,0x00,0x00,0x06,0x00,0x00,
		0x00,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oQuarterRestMask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x1C,0x00,0x00,0x00,0x1F,0x00,0x00,0x00,0x1F,0x80,0x00,0x00,0x0F,0x80,0x00,
		0x00,0x0F,0x80,0x00,0x00,0x0F,0x80,0x00,0x00,0x0F,0x80,0x00,0x00,0x0F,0xC0,0x00,
		0x00,0x1F,0xC0,0x00,0x00,0x1F,0xC0,0x00,0x00,0x1F,0x00,0x00,0x00,0x1F,0x80,0x00,
		0x00,0x0F,0x80,0x00,0x00,0x03,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oHalfRestImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x1F,0xC0,0x00,0x00,0x1F,0xC0,0x00,0x00,0x1F,0xC0,0x00,0x00,0xFF,0xF8,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oHalfRestMask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0xE0,0x00,
		0x00,0x3F,0xE0,0x00,0x00,0x3F,0xE0,0x00,0x01,0xFF,0xFC,0x00,0x01,0xFF,0xFC,0x00,
		0x01,0xFF,0xFC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oWholeRestImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xF8,0x00,
		0x00,0x1F,0xC0,0x00,0x00,0x1F,0xC0,0x00,0x00,0x1F,0xC0,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oWholeRestMask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xFF,0xFC,0x00,0x01,0xFF,0xFC,0x00,
		0x01,0xFF,0xFC,0x00,0x00,0x3F,0xE0,0x00,0x00,0x3F,0xE0,0x00,0x00,0x3F,0xE0,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oDoubleRestImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xF8,0x00,
		0x00,0x1D,0xC0,0x00,0x00,0x1D,0xC0,0x00,0x00,0x1D,0xC0,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oDoubleRestMask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xFF,0xFC,0x00,0x01,0xFF,0xFC,0x00,
		0x01,0xFF,0xFC,0x00,0x00,0x3F,0xE0,0x00,0x00,0x3F,0xE0,0x00,0x00,0x3F,0xE0,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oQuadRestImage[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xFF,0xFC,0x00,
		0x00,0x6D,0xB0,0x00,0x00,0x6D,0xB0,0x00,0x00,0x6D,0xB0,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oQuadRestMask[] =
	{
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xFF,0xFE,0x00,0x03,0xFF,0xFE,0x00,
		0x03,0xFF,0xFE,0x00,0x00,0xFF,0xF8,0x00,0x00,0xFF,0xF8,0x00,0x00,0xFF,0xF8,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	};

static char									oGreyMask[] =
	{
		0x55,0x55,0x55,0x55,0xAA,0xAA,0xAA,0xAA,0x55,0x55,0x55,0x55,0xAA,0xAA,0xAA,0xAA,
		0x55,0x55,0x55,0x55,0xAA,0xAA,0xAA,0xAA,0x55,0x55,0x55,0x55,0xAA,0xAA,0xAA,0xAA,
		0x55,0x55,0x55,0x55,0xAA,0xAA,0xAA,0xAA,0x55,0x55,0x55,0x55,0xAA,0xAA,0xAA,0xAA,
		0x55,0x55,0x55,0x55,0xAA,0xAA,0xAA,0xAA,0x55,0x55,0x55,0x55,0xAA,0xAA,0xAA,0xAA,
		0x55,0x55,0x55,0x55,0xAA,0xAA,0xAA,0xAA,0x55,0x55,0x55,0x55,0xAA,0xAA,0xAA,0xAA,
		0x55,0x55,0x55,0x55,0xAA,0xAA,0xAA,0xAA,0x55,0x55,0x55,0x55,0xAA,0xAA,0xAA,0xAA,
		0x55,0x55,0x55,0x55,0xAA,0xAA,0xAA,0xAA,0x55,0x55,0x55,0x55,0xAA,0xAA,0xAA,0xAA,
		0x55,0x55,0x55,0x55,0xAA,0xAA,0xAA,0xAA,0x55,0x55,0x55,0x55,0xAA,0xAA,0xAA,0xAA
	};


MyBoolean						InitializeNoteImages(void)
	{
		ERROR(Initialized,PRERR(ForceAbort,"InitializeNoteImages:  already initialized"));
		EXECUTE(Initialized = True;)
		/* we do not watch for out of memory conditions because this should be */
		/* called early when there is plenty of memory available */
		SixtyFourthNoteImage = MakeBitmap(oSixtyFourthNoteImage,32,32,4);
		if (SixtyFourthNoteImage == NIL)
			{
			 FailurePoint1:
				return False;
			}
		SixtyFourthNoteMask = MakeBitmap(oSixtyFourthNoteMask,32,32,4);
		if (SixtyFourthNoteMask == NIL)
			{
			 FailurePoint2:
				DisposeBitmap(SixtyFourthNoteImage);
				goto FailurePoint1;
			}
		ThirtySecondNoteImage = MakeBitmap(oThirtySecondNoteImage,32,32,4);
		if (ThirtySecondNoteImage == NIL)
			{
			 FailurePoint3:
				DisposeBitmap(SixtyFourthNoteMask);
				goto FailurePoint2;
			}
		ThirtySecondNoteMask = MakeBitmap(oThirtySecondNoteMask,32,32,4);
		if (ThirtySecondNoteMask == NIL)
			{
			 FailurePoint4:
				DisposeBitmap(ThirtySecondNoteImage);
				goto FailurePoint3;
			}
		SixteenthNoteImage = MakeBitmap(oSixteenthNoteImage,32,32,4);
		if (SixteenthNoteImage == NIL)
			{
			 FailurePoint5:
				DisposeBitmap(ThirtySecondNoteMask);
				goto FailurePoint4;
			}
		SixteenthNoteMask = MakeBitmap(oSixteenthNoteMask,32,32,4);
		if (SixteenthNoteMask == NIL)
			{
			 FailurePoint6:
				DisposeBitmap(SixteenthNoteImage);
				goto FailurePoint5;
			}
		EighthNoteImage = MakeBitmap(oEighthNoteImage,32,32,4);
		if (EighthNoteImage == NIL)
			{
			 FailurePoint7:
				DisposeBitmap(SixteenthNoteMask);
				goto FailurePoint6;
			}
		EighthNoteMask = MakeBitmap(oEighthNoteMask,32,32,4);
		if (EighthNoteMask == NIL)
			{
			 FailurePoint8:
				DisposeBitmap(EighthNoteImage);
				goto FailurePoint7;
			}
		QuarterNoteImage = MakeBitmap(oQuarterNoteImage,32,32,4);
		if (QuarterNoteImage == NIL)
			{
			 FailurePoint9:
				DisposeBitmap(EighthNoteMask);
				goto FailurePoint8;
			}
		QuarterNoteMask = MakeBitmap(oQuarterNoteMask,32,32,4);
		if (QuarterNoteMask == NIL)
			{
			 FailurePoint10:
				DisposeBitmap(QuarterNoteImage);
				goto FailurePoint9;
			}
		HalfNoteImage = MakeBitmap(oHalfNoteImage,32,32,4);
		if (HalfNoteImage == NIL)
			{
			 FailurePoint11:
				DisposeBitmap(QuarterNoteMask);
				goto FailurePoint10;
			}
		HalfNoteMask = MakeBitmap(oHalfNoteMask,32,32,4);
		if (HalfNoteMask == NIL)
			{
			 FailurePoint12:
				DisposeBitmap(HalfNoteImage);
				goto FailurePoint11;
			}
		WholeNoteImage = MakeBitmap(oWholeNoteImage,32,32,4);
		if (WholeNoteImage == NIL)
			{
			 FailurePoint13:
				DisposeBitmap(HalfNoteMask);
				goto FailurePoint12;
			}
		WholeNoteMask = MakeBitmap(oWholeNoteMask,32,32,4);
		if (WholeNoteMask == NIL)
			{
			 FailurePoint14:
				DisposeBitmap(WholeNoteImage);
				goto FailurePoint13;
			}
		DoubleNoteImage = MakeBitmap(oDoubleNoteImage,32,32,4);
		if (DoubleNoteImage == NIL)
			{
			 FailurePoint15:
				DisposeBitmap(WholeNoteMask);
				goto FailurePoint14;
			}
		DoubleNoteMask = MakeBitmap(oDoubleNoteMask,32,32,4);
		if (DoubleNoteMask == NIL)
			{
			 FailurePoint16:
				DisposeBitmap(DoubleNoteImage);
				goto FailurePoint15;
			}
		QuadNoteImage = MakeBitmap(oQuadNoteImage,32,32,4);
		if (QuadNoteImage == NIL)
			{
			 FailurePoint17:
				DisposeBitmap(DoubleNoteMask);
				goto FailurePoint16;
			}
		QuadNoteMask = MakeBitmap(oQuadNoteMask,32,32,4);
		if (QuadNoteMask == NIL)
			{
			 FailurePoint18:
				DisposeBitmap(QuadNoteImage);
				goto FailurePoint17;
			}
		DotImage = MakeBitmap(oDotImage,32,32,4);
		if (DotImage == NIL)
			{
			 FailurePoint19:
				DisposeBitmap(QuadNoteMask);
				goto FailurePoint18;
			}
		DotMask = MakeBitmap(oDotMask,32,32,4);
		if (DotMask == NIL)
			{
			 FailurePoint20:
				DisposeBitmap(DotImage);
				goto FailurePoint19;
			}
		SharpImage = MakeBitmap(oSharpImage,32,32,4);
		if (SharpImage == NIL)
			{
			 FailurePoint21:
				DisposeBitmap(DotMask);
				goto FailurePoint20;
			}
		SharpMask = MakeBitmap(oSharpMask,32,32,4);
		if (SharpMask == NIL)
			{
			 FailurePoint22:
				DisposeBitmap(SharpImage);
				goto FailurePoint21;
			}
		FlatImage = MakeBitmap(oFlatImage,32,32,4);
		if (FlatImage == NIL)
			{
			 FailurePoint23:
				DisposeBitmap(SharpMask);
				goto FailurePoint22;
			}
		FlatMask = MakeBitmap(oFlatMask,32,32,4);
		if (FlatMask == NIL)
			{
			 FailurePoint24:
				DisposeBitmap(FlatImage);
				goto FailurePoint23;
			}
		NaturalImage = MakeBitmap(oNaturalImage,32,32,4);
		if (NaturalImage == NIL)
			{
			 FailurePoint25:
				DisposeBitmap(FlatMask);
				goto FailurePoint24;
			}
		NaturalMask = MakeBitmap(oNaturalMask,32,32,4);
		if (NaturalMask == NIL)
			{
			 FailurePoint26:
				DisposeBitmap(NaturalImage);
				goto FailurePoint25;
			}
		SortaSharpImage = MakeBitmap(oSortaSharpImage,32,32,4);
		if (SortaSharpImage == NIL)
			{
			 FailurePoint27:
				DisposeBitmap(NaturalMask);
				goto FailurePoint26;
			}
		SortaSharpMask = MakeBitmap(oSortaSharpMask,32,32,4);
		if (SortaSharpMask == NIL)
			{
			 FailurePoint28:
				DisposeBitmap(SortaSharpImage);
				goto FailurePoint27;
			}
		SortaFlatImage = MakeBitmap(oSortaFlatImage,32,32,4);
		if (SortaFlatImage == NIL)
			{
			 FailurePoint29:
				DisposeBitmap(SortaSharpMask);
				goto FailurePoint28;
			}
		SortaFlatMask = MakeBitmap(oSortaFlatMask,32,32,4);
		if (SortaFlatMask == NIL)
			{
			 FailurePoint30:
				DisposeBitmap(SortaFlatImage);
				goto FailurePoint29;
			}
		Div3Image = MakeBitmap(oDiv3Image,32,32,4);
		if (Div3Image == NIL)
			{
			 FailurePoint31:
				DisposeBitmap(SortaFlatMask);
				goto FailurePoint30;
			}
		Div3Mask = MakeBitmap(oDiv3Mask,32,32,4);
		if (Div3Mask == NIL)
			{
			 FailurePoint32:
				DisposeBitmap(Div3Image);
				goto FailurePoint31;
			}
		Div5Image = MakeBitmap(oDiv5Image,32,32,4);
		if (Div5Image == NIL)
			{
			 FailurePoint33:
				DisposeBitmap(Div3Mask);
				goto FailurePoint32;
			}
		Div5Mask = MakeBitmap(oDiv5Mask,32,32,4);
		if (Div5Mask == NIL)
			{
			 FailurePoint34:
				DisposeBitmap(Div5Image);
				goto FailurePoint33;
			}
		Div7Image = MakeBitmap(oDiv7Image,32,32,4);
		if (Div7Image == NIL)
			{
			 FailurePoint35:
				DisposeBitmap(Div5Mask);
				goto FailurePoint34;
			}
		Div7Mask = MakeBitmap(oDiv7Mask,32,32,4);
		if (Div7Mask == NIL)
			{
			 FailurePoint36:
				DisposeBitmap(Div7Image);
				goto FailurePoint35;
			}
		SixtyFourthRestImage = MakeBitmap(oSixtyFourthRestImage,32,32,4);
		if (SixtyFourthRestImage == NIL)
			{
			 FailurePoint37:
				DisposeBitmap(Div7Mask);
				goto FailurePoint36;
			}
		SixtyFourthRestMask = MakeBitmap(oSixtyFourthRestMask,32,32,4);
		if (SixtyFourthRestMask == NIL)
			{
			 FailurePoint38:
				DisposeBitmap(SixtyFourthRestImage);
				goto FailurePoint37;
			}
		ThirtySecondRestImage = MakeBitmap(oThirtySecondRestImage,32,32,4);
		if (ThirtySecondRestImage == NIL)
			{
			 FailurePoint39:
				DisposeBitmap(SixtyFourthRestMask);
				goto FailurePoint38;
			}
		ThirtySecondRestMask = MakeBitmap(oThirtySecondRestMask,32,32,4);
		if (ThirtySecondRestMask == NIL)
			{
			 FailurePoint40:
				DisposeBitmap(ThirtySecondRestImage);
				goto FailurePoint39;
			}
		SixteenthRestImage = MakeBitmap(oSixteenthRestImage,32,32,4);
		if (SixteenthRestImage == NIL)
			{
			 FailurePoint41:
				DisposeBitmap(ThirtySecondRestMask);
				goto FailurePoint40;
			}
		SixteenthRestMask = MakeBitmap(oSixteenthRestMask,32,32,4);
		if (SixteenthRestMask == NIL)
			{
			 FailurePoint42:
				DisposeBitmap(SixteenthRestImage);
				goto FailurePoint41;
			}
		EighthRestImage = MakeBitmap(oEighthRestImage,32,32,4);
		if (EighthRestImage == NIL)
			{
			 FailurePoint43:
				DisposeBitmap(SixteenthRestMask);
				goto FailurePoint42;
			}
		EighthRestMask = MakeBitmap(oEighthRestMask,32,32,4);
		if (EighthRestMask == NIL)
			{
			 FailurePoint44:
				DisposeBitmap(EighthRestImage);
				goto FailurePoint43;
			}
		QuarterRestImage = MakeBitmap(oQuarterRestImage,32,32,4);
		if (QuarterRestImage == NIL)
			{
			 FailurePoint45:
				DisposeBitmap(EighthRestMask);
				goto FailurePoint44;
			}
		QuarterRestMask = MakeBitmap(oQuarterRestMask,32,32,4);
		if (QuarterRestMask == NIL)
			{
			 FailurePoint46:
				DisposeBitmap(QuarterRestImage);
				goto FailurePoint45;
			}
		HalfRestImage = MakeBitmap(oHalfRestImage,32,32,4);
		if (HalfRestImage == NIL)
			{
			 FailurePoint47:
				DisposeBitmap(QuarterRestMask);
				goto FailurePoint46;
			}
		HalfRestMask = MakeBitmap(oHalfRestMask,32,32,4);
		if (HalfRestMask == NIL)
			{
			 FailurePoint48:
				DisposeBitmap(HalfRestImage);
				goto FailurePoint47;
			}
		WholeRestImage = MakeBitmap(oWholeRestImage,32,32,4);
		if (WholeRestImage == NIL)
			{
			 FailurePoint49:
				DisposeBitmap(HalfRestMask);
				goto FailurePoint48;
			}
		WholeRestMask = MakeBitmap(oWholeRestMask,32,32,4);
		if (WholeRestMask == NIL)
			{
			 FailurePoint50:
				DisposeBitmap(WholeRestImage);
				goto FailurePoint49;
			}
		DoubleRestImage = MakeBitmap(oDoubleRestImage,32,32,4);
		if (DoubleRestImage == NIL)
			{
			 FailurePoint51:
				DisposeBitmap(WholeRestMask);
				goto FailurePoint50;
			}
		DoubleRestMask = MakeBitmap(oDoubleRestMask,32,32,4);
		if (DoubleRestMask == NIL)
			{
			 FailurePoint52:
				DisposeBitmap(DoubleRestImage);
				goto FailurePoint51;
			}
		QuadRestImage = MakeBitmap(oQuadRestImage,32,32,4);
		if (QuadRestImage == NIL)
			{
			 FailurePoint53:
				DisposeBitmap(DoubleRestMask);
				goto FailurePoint52;
			}
		QuadRestMask = MakeBitmap(oQuadRestMask,32,32,4);
		if (QuadRestMask == NIL)
			{
			 FailurePoint54:
				DisposeBitmap(QuadRestImage);
				goto FailurePoint53;
			}
		GreyMask = MakeBitmap(oGreyMask,32,32,4);
		if (GreyMask == NIL)
			{
			 FailurePoint55:
				DisposeBitmap(QuadRestMask);
				goto FailurePoint54;
			}
		return True;
	}


void								CleanupNoteImages(void)
	{
		ERROR(!Initialized,PRERR(ForceAbort,"CleanupNoteImages:  not initialized"));
		EXECUTE(Initialized = False;)
		DisposeBitmap(SixtyFourthNoteImage);
		DisposeBitmap(SixtyFourthNoteMask);
		DisposeBitmap(ThirtySecondNoteImage);
		DisposeBitmap(ThirtySecondNoteMask);
		DisposeBitmap(SixteenthNoteImage);
		DisposeBitmap(SixteenthNoteMask);
		DisposeBitmap(EighthNoteImage);
		DisposeBitmap(EighthNoteMask);
		DisposeBitmap(QuarterNoteImage);
		DisposeBitmap(QuarterNoteMask);
		DisposeBitmap(HalfNoteImage);
		DisposeBitmap(HalfNoteMask);
		DisposeBitmap(WholeNoteImage);
		DisposeBitmap(WholeNoteMask);
		DisposeBitmap(DoubleNoteImage);
		DisposeBitmap(DoubleNoteMask);
		DisposeBitmap(QuadNoteImage);
		DisposeBitmap(QuadNoteMask);
		DisposeBitmap(DotImage);
		DisposeBitmap(DotMask);
		DisposeBitmap(SharpImage);
		DisposeBitmap(SharpMask);
		DisposeBitmap(FlatImage);
		DisposeBitmap(FlatMask);
		DisposeBitmap(NaturalImage);
		DisposeBitmap(NaturalMask);
		DisposeBitmap(SortaSharpImage);
		DisposeBitmap(SortaSharpMask);
		DisposeBitmap(SortaFlatImage);
		DisposeBitmap(SortaFlatMask);
		DisposeBitmap(Div3Image);
		DisposeBitmap(Div3Mask);
		DisposeBitmap(Div5Image);
		DisposeBitmap(Div5Mask);
		DisposeBitmap(Div7Image);
		DisposeBitmap(Div7Mask);
		DisposeBitmap(SixtyFourthRestImage);
		DisposeBitmap(SixtyFourthRestMask);
		DisposeBitmap(ThirtySecondRestImage);
		DisposeBitmap(ThirtySecondRestMask);
		DisposeBitmap(SixteenthRestImage);
		DisposeBitmap(SixteenthRestMask);
		DisposeBitmap(EighthRestImage);
		DisposeBitmap(EighthRestMask);
		DisposeBitmap(QuarterRestImage);
		DisposeBitmap(QuarterRestMask);
		DisposeBitmap(HalfRestImage);
		DisposeBitmap(HalfRestMask);
		DisposeBitmap(WholeRestImage);
		DisposeBitmap(WholeRestMask);
		DisposeBitmap(DoubleRestImage);
		DisposeBitmap(DoubleRestMask);
		DisposeBitmap(QuadRestImage);
		DisposeBitmap(QuadRestMask);
		DisposeBitmap(GreyMask);
	}
