/* SampleTestPlay.h */

#ifndef Included_SampleTestPlay_h
#define Included_SampleTestPlay_h

/* SampleTestPlay module depends on */
/* MiscInfo.h */
/* Audit */
/* Debug */
/* Definitions */
/* SoundOutput */
/* Memory */
/* SampleWindow */
/* SampleConsts */

/* forward declarations */
struct SampleWindowRec;

/* determine if one is in progress */
MyBoolean					SampleTestPlayInProgress(void);

/* determine if the sample is finished & we just need to clean up */
MyBoolean					SampleTestIsWaitingForCleanup(void);

/* call back which does all the work.  When sample is finished playing, it */
/* will clean itself up and SampleTestPlayInProgress will return False. */
void							SampleTestPlayCallback(struct SampleWindowRec* TheWindow,
										MyBoolean IgnoreMe);

/* find out if it is still playing the sample loop */
MyBoolean					SampleTestIsItLooping(void);

/* tell the thing to stop looping */
void							SampleTestBreakLoop(void);

typedef enum
	{
		eSampleTestNoError EXECUTE(= -18115),
		eSampleTestNoSample,
		eSampleTestCouldntOpenChannel
	} SampleTestErrors;

/* see if an error occurred */
SampleTestErrors	SampleTestDidErrorOccur(void);

/* clean up internal data structures */
void							SampleTestPlayCleanup(void);

#endif
