//----------------------------------------------------------------------------------
// File		: test3D.r
// Date		: July 23, 1994
// Author	: Jim Stout
//			:
// Purpose	: rez source for test3D.c
//----------------------------------------------------------------------------------
#include <Types.r> 
include "debug.rsrc";			// contains the dummy CDEF 128

#define CDEF 128				// used in CNTL templates below
#define wf 8
#define WANT3D true				// set to false for normal buttons

// this resource will be set by test3D.c and used by the dummy CDEF

data 'CJMP' (128, "CDEFmain address") {
	$"0000 0000"
};

// this resource will color ALL controls (since it's id=0) in an application

resource 'cctb' (0) {
	{
		cBodyColor, 61166, 61166, 61166,
		cTextColor, 0, 0, 0,
		cFrameColor, 384, 384, 26214,
	}
};

// this resource will color dialog id=128 - and is needed to allow the 'cctb' to work
// change wContentColor from white to see the control drawn as a "3D control".

resource 'dctb' (128) {
	{	/* array ColorSpec: 5 elements */
#if WANT3D
		/* [1] */		wContentColor, 52428, 52428, 52428,		// gray background
#else
		/* [1] */		wContentColor, 65535, 65535, 65535,		// white background
#endif
		/* [2] */		wFrameColor, 0, 0, 0,
		/* [3] */		wTextColor, 0, 0, 0,
		/* [4] */		wHiliteColor, 0, 0, 0,
		/* [5] */		wTitleBarColor, 65535, 65535, 65535
	}
};

resource 'DLOG' (128) {
	{44, 20, 274, 440},	movableDBoxProc,	visible,	nogoAway,	0x0,	128,	"Test 3D CDEF"
};

resource 'DITL' (128) {
	{
		/* [1] */	{197, 348, 217, 407},		Button		{	enabled,	"OK"			},
		/* [2] */	{167, 348, 187, 407},		Button 		{	enabled,	"Cancel"		},
		/* [3] */	{15, 300, 31, 410},			StaticText	{	disabled, 	"System CDEF"	},
		/* [4] */	{40, 300, 56, 410},			CheckBox 	{	enabled,	"CheckBox"		},
		/* [5] */	{66, 300, 98, 410},			CheckBox 	{	enabled,	"2 line\nTitle"	}, 
		/* [6] */	{107, 300, 123, 410},		RadioButton {	enabled,	"RadioButton 1"	},
		/* [7] */	{128, 300, 144, 410},		RadioButton {	enabled,	"RadioButton 2"	},
	
		/* [8] */	{197, 208, 217, 267},		Control		{	enabled,	128				},
		/* [9] */	{167, 208, 187, 267},		Control 	{	enabled,	129				},
		/* [10] */	{15, 160, 31, 290},			StaticText	{	disabled, 	"3D CDEF"	},
		/* [11] */	{40, 160, 56, 290},			Control 	{	enabled,	130				},
		/* [12] */	{66, 160, 98, 290},			Control 	{	enabled,	131				},
		/* [13] */	{107, 160, 123, 290},		Control 	{	enabled,	132				},
		/* [14] */	{128, 160, 144, 290},		Control 	{	enabled,	133				},
		
		/* [15] */	{15, 20, 31, 150},			StaticText	{	disabled, 	"'Tog' Buttons"	},
		/* [16] */	{40, 20, 56, 250},			Control		{	enabled, 	134				},
		/* [17] */	{61, 20, 77, 250},			Control		{	enabled, 	135				},
		/* [18] */	{82, 20, 98, 250},			Control		{	enabled, 	136				},
		/* [19] */	{103, 20, 119, 250},		Control		{	enabled, 	137				}
	}
};

// make sure the RECTs for the CNTL resources match the DITL rects above or your your
// dialog will 'flash' when it is drawn.

resource 'CNTL' (128) {
	{197, 208, 217, 267},0,	visible,	1,		0,	16*CDEF+pushButProc+wf,		0,	"OK"
};
resource 'CNTL' (129) {
	{167, 208, 187, 267},0,	visible,	1,		0,	16*CDEF+pushButProc+wf,		0,	"Cancel"
};
resource 'CNTL' (130) {
	{40, 160, 56, 290},	0,	visible,	1,		0,	16*CDEF+checkBoxProc+wf,	0,	"CheckBox"
};
resource 'CNTL' (131) {
	{66, 160, 98, 290},	0,	visible,	1,		0,	16*CDEF+checkBoxProc+wf,	0,	"2 line\nTitle"
};
resource 'CNTL' (132) {
	{107, 160, 123, 290},1,	visible,	1,		0,	16*CDEF+radioButProc+wf,	0,	"RadioButton 1"
};
resource 'CNTL' (133) {
	{128, 160, 144, 290},0,	visible,	1,		0,	16*CDEF+radioButProc+wf,	0,	"RadioButton 2"
};

resource 'CNTL' (134) {
	{40, 20, 56, 250},1,	visible,	1,		0,	16*CDEF+4+wf,				0,	"Tog Button 1"
};
resource 'CNTL' (135) {
	{61, 20, 77, 250},0,	visible,	1,		0,	16*CDEF+4+wf,				0,	"Tog Button 2"
};
resource 'CNTL' (136) {
	{82, 20, 98, 250},0,	visible,	1,		0,	16*CDEF+4+wf,				0,	"Tog Button 3"
};
resource 'CNTL' (137) {
	{103, 20, 119, 250},0,	visible,	1,		0,	16*CDEF+4+wf,				0,	"Tog Button 4"
};